/*****************************************************************/
/* ADS7843.H definition file for ADS7843 touch screen controller */
/*****************************************************************/
/* Controll byte structure					 */
/*								 */
/* Bit7 Bit6 Bit5 Bit4 Bit3 Bit2     Bit1 Bit0 			 */
/*  1    A2   A1   A0  Mode SER/DFRn PD1  PD0			 */
/*---------------------------------------------------------------*/
/* meaning for X+ and Y+ use only for more detail refer to manual*/
/*								 */
/* A2  A1  A0  X+  Y+  XSwitch YSwitch				 */
/* 0   0   1  +IN  -    OFF      ON				 */
/* 1   0   1   -  +IN   ON       OFF				 */ 
/* x   1   x   -   -    OFF      OFF				 */ 
/*****************************************************************/
#define  S	         0x80
#define  READ_X	  0x10
#define  ADC_IN3	  0x20
#define  READ_Y	  0x50
#define  ADC_IN4	  0x60
#define   _8BitMode    0x08
#define  _12BitMode    0x00
#define  SingleEnded   0x04
#define  Differential  0x00
#define  PD_IRQenable  0x00
#define  PD_IRQdisable 0x01
#define  PD_Off	  0x03

#define		ADS_CS		p8_addr.bit.b4		/* Port P8  bit4 */

/* function declarations */
void far wait( unsigned char time2wait); 
void far ADS_init();
char far XY_pos_rd_pd( unsigned int * xpos, unsigned int * ypos);
char far XY_pos_rd( unsigned int * xpos, unsigned int * ypos);
void far clock_out(unsigned char controll);

extern unsigned int xpos;
extern unsigned int ypos;

extern char  new_touch_value;

