/*******************************************************************************
*
* t`qs֐AZgjNXo͑u֐
*
* Copyright 1995, MITSUBISHI ELECTRIC CORPORATION
* AND MITSUBISHI ELECTRIC SEMICONDUCTOR SOFTWARE CORPORATION
* All Rights Reserved.
*
*  $Id: device.c,v 1.1 97/01/31 13:55:00 kawajiri Exp $
*
*	NC30 Version 0.00.00
*
*******************************************************************************/


#if defined(NC30)		/* NCxx */
	/* dummy */
#elif defined(NC77)
	#error "NC77 not supported"
#elif defined(NC79)
	#error "NC79 not supported"
#else
	#error "NC30, NC77, NC79 not defined"
#endif				/* NCxx */



#define M16C

#include <stdio.h>
#include "sfr62.h"

#ifdef M16C

#ifdef UART0
#pragma EQU _porta  =   0x3EC           /*  */
#pragma EQU _pa_vct =   0x3EE           /*  */
#pragma EQU _portb  =   0x3ED           /*  */
#pragma EQU _pb_vct =   0x3EF           /*  */
#pragma EQU _mode1  =   0x3A0           /*  */
#pragma EQU _brg1   =   0x3A1           /*  */
#pragma EQU _sbuf1  =   0x3A2           /*  */
#pragma EQU _cntr1_l =  0x3A4           /*  */
#pragma EQU _cntr1_h =  0x3A5           /*  */
#pragma EQU _rbuf1  =   0x3A6           /*  */
#else /* UART1 : default */
#pragma EQU _porta  =   0x3E8           /*  */
#pragma EQU _pa_vct =   0x3EA           /*  */
#pragma EQU _portb  =   0x3E9           /*  */
#pragma EQU _pb_vct =   0x3EB           /*  */
#pragma EQU _mode1  =   0x3A8           /*  */
#pragma EQU _brg1   =   0x3A9           /*  */
#pragma EQU _sbuf1  =   0x3AA           /*  */
#pragma EQU _cntr1_l =  0x3AC           /*  */
#pragma EQU _cntr1_h =  0x3AD           /*  */
#pragma EQU _rbuf1  =   0x3AE           /*  */
#endif

#define TXEPTY  0x8                     /* */
#define TE      0x1                     /* */
#define TI      0x2                     /* */
#define RE      0x4                     /* */
#define RI      0x8                     /* */

#define ACK     0x40
#define BUSY    0x20
#define FAULT   0x10
#define RESET   0x8
#define STROBE  0x4

#define TRUE    1

char _porta;
char _pa_vct;
char _portb;
char _pb_vct;
char _mode1;
char _brg1;
char _sbuf1;
char _cntr1_l;
char _cntr1_h;
char _rbuf1;

#define	BRG192		51	/* f1(16Mhz/1) / 16 / 19200 - 1 = 51	*/
#define CNTR192		16	/* f1					*/
#define	BRG96		103	/* f1(16Mhz/1) / 16 /  9600 - 1 = 103	*/
#define CNTR96		16	/* f1					*/
#define	BRG48		207	/* f1(16Mhz/1) / 16 /  4800 - 1 = 207	*/
#define CNTR48		16	/* f1					*/
#define	BRG24		51	/* f8(16Mhz/8) / 16 /  2400 - 1 = 51	*/
#define CNTR24		17	/* f8					*/
#define	BRG12		103	/* f8(16Mhz/8) / 16 /  1200 - 1 = 103	*/
#define CNTR12		17	/* f8 CTS RTS disabled			*/
#endif	/* M16C */

/*******************************************************************************
*
* init_dev 
*
* Copyright 1988, 1989, 1990, 1991, 1992, MITSUBISHI ELECTRIC CORPORATION
* AND MITSUBISHI ELECTRIC SEMICONDUCTOR SOFTWARE CORPORATION
* All Rights Reserved.
*
* L^: Version 2.00.00
* 	    Version 2.01.00
*		[WfΉ
*
* ֐    init_dev -- foCX̃[hݒ
*
* @    status = init_dev( stream, mode )
*
*           #include <stdio.h>
*           FILE *stream        Xg[̃|C^
*           int  mode;          [h
*           int  status;        ^[R[h
*
* ߂l    ɐݒłꍇAPԂBɌ肪ꍇAdneԂB
*
* @@\    w肵Xg[̃[hݒ肷B
*
*******************************************************************************/

int init_dev( stream, mode )
FILE _far *stream;
int  mode;
{
    if ( mode != _TEXT && mode != _BIN )
        return  EOF;
    stream->_mod = mode;
    return  TRUE;
}


/*******************************************************************************
*
* speed 
*
* Copyright 1988, 1989, 1990, 1991, 1992, MITSUBISHI ELECTRIC CORPORATION
* AND MITSUBISHI ELECTRIC SEMICONDUCTOR SOFTWARE CORPORATION
* All Rights Reserved.
*
* 	    Version 2.01.00
* 	    Version 3.00.00
*
*           status = speed( rate, bit, parity, stop );
*
*           #include <stdio.h>
*           int  rate;         
*           int  bit;          
*           int  parity;       
*           int  stop;         
*           int  status;       
*
* 
*
* 
* 
*
*******************************************************************************/

int speed( rate, bit, parity, stop )
int  rate;                              /*  */
int  bit;                               /*  */
int  parity;                            /*  */
int  stop;                              /*  */
{						  
    int mode;                           /*  */

    _pa_vct &= 0xF7;                    /* set RXD to input and TXD to output */
    _pa_vct |= 0x08;                    /* set RXD to input and TXD to output */

    _cntr1_h = NULL;                    /*  */
    switch( rate ) {                    /*  */
        case _96:
            _brg1 = BRG96;
            _cntr1_l = CNTR96;
            break;
        case _48:
            _brg1 = BRG48;
            _cntr1_l = CNTR48;
            break;
        case _24:
            _brg1 = BRG24;
            _cntr1_l = CNTR24;
            break;
        case _12:
            _brg1 = BRG12;
            _cntr1_l = CNTR12;
            break;
        default:
            return EOF;
    }
    switch( bit ) {                     /* f[^̐ݒ */
        case _B8:
            mode = 0x5;
            break;
        case _B7:
            mode = 0x4;
            break;
        default:
            return EOF;
    }
    switch( parity ) {                  /* peB̎w */
        case _PN:
            break;
        case _PE:
            mode |= 0x60;
            break;
        case _PO:
            mode |= 0x40;
            break;
        default:
            return EOF;
    }
    switch( stop ) {                    /* Xgbvrbg̐ݒ */
        case _S1:
            break;
        case _S2:
            mode |= 0x10;
            break;
        default:
            return EOF;
    }
    _mode1 = mode;
    return  TRUE;
}


/*******************************************************************************
*
* ini_prn 
*
* Copyright 1988, 1989, 1990, 1991, 1992, MITSUBISHI ELECTRIC CORPORATION
* AND MITSUBISHI ELECTRIC SEMICONDUCTOR SOFTWARE CORPORATION
* All Rights Reserved.
*
* L^: Version 2.00.00
* 	    Version 2.01.00
*		[WfΉ
*
* ֐    ini_prn -- ZgjNXo͑ȕݒ
*
* @    status = init_prn( void );
*
*           int  status;        ^[R[h
*
* ߂l    ɏݒ肪sꍇAPԂBv^G[̏ꍇA
*           dneԂB
*
* @@\    ob`SXVVΉ̃ZgjNXo͑ȕݒsB
*
*******************************************************************************/

int init_prn()
{
    int i;

    _porta = STROBE | RESET;            /* lݒ */
    _pa_vct = 0x8c;                     /* |[gSWX^ */
    _portb = NULL;                      /* lݒ */
    _pb_vct = 0xff;                     /* |[gTWX^ */
    _porta = STROBE;                    /* RESETiRESETMLANeBuj*/
    for ( i = 0 ; i < 0x50 ; i++ ) ;    /* EGCg */
    _porta = RESET | STROBE;            /* RESET */
    for ( i = 0 ; i < 0x50 ; i++ ) ;    /* EGCg */
    if ( _porta & FAULT )
        return EOF;
    else
        return TRUE;
}


/*******************************************************************************
*
* _sget 
*
* Copyright 1988, 1989, 1990, 1991, 1992, MITSUBISHI ELECTRIC CORPORATION
* AND MITSUBISHI ELECTRIC SEMICONDUCTOR SOFTWARE CORPORATION
* All Rights Reserved.
*
* L^: Version 2.00.00
* 	    Version 2.01.00
*		[WfΉ
*
* ֐    _sget -- t`qŝP
*
* @    data = _sget( void );
*
*           int  data;      ͕
*
* ߂l    ɓ͂łꍇA͂ԂBG[̏ꍇAdne
*           ԂB
*
* @@\    t`qsP͂B
*
*******************************************************************************/


int _sget( )                            /* t`qsP͂ */
{
    int  data;

    _cntr1_h = _cntr1_h | RE;           /* MtOZbg */
#ifndef XRAY_SIMULATOR
    while ( !( _cntr1_h & RI ) ) ;      /* MtOZbg܂ŃEGCg */
#endif
    data = _rbuf1;
    return data;
}


/*******************************************************************************
*
* _sput 
*
* Copyright 1988, 1989, 1990, 1991, 1992, MITSUBISHI ELECTRIC CORPORATION
* AND MITSUBISHI ELECTRIC SEMICONDUCTOR SOFTWARE CORPORATION
* All Rights Reserved.
*
* L^: Version 2.00.00
* 	    Version 2.01.00
*		[WfΉ
*
* ֐    _sput -- t`qŝPo
*
* @    status = _sput( c );
*
*           int  c;         o͂镶
*           int  status;    ^[R[h
*
* ߂l    ɏo͂łꍇAPԂBG[̏ꍇAdneԂB
*
* @@\    t`qsPo͂B
*
*******************************************************************************/


int _sput( c )                          /* t`qsPo͂ */
int c;
{
    int i;

    _cntr1_h = _cntr1_h | TE;           /* MtOZbg */
#ifndef XRAY_SIMULATOR
    while ( !( _cntr1_h & TI ) ) ;      /* Mobt@tOZbg܂ŃEGCg */
#endif
    _sbuf1 = c;
    if ( _cntr1_h & 0xf0 )
        return EOF;                     /* G[̏ꍇ */
    return  TRUE;
}


/*******************************************************************************
*
* _pput 
*
* Copyright 1988, 1989, 1990, 1991, 1992, MITSUBISHI ELECTRIC CORPORATION
* AND MITSUBISHI ELECTRIC SEMICONDUCTOR SOFTWARE CORPORATION
* All Rights Reserved.
*
* L^: Version 2.00.00
* 	    Version 2.01.00
*		[WfΉ
*
* ֐    _pput -- ZgjNXo͑ûPo
*
* @    status = _pput( c );
*
*           int  c;         o͂镶
*           int  status;    ^[R[h
*
* ߂l    ɏo͂łꍇAPԂBG[̏ꍇAdneԂB
*
* @@\    ZgjNXo͑uPo͂B
*
*******************************************************************************/

int _pput( c )                          /* ZgjNXo͑uPo͂ */
int c;
{
    int  i;

    if ( _porta & FAULT )
        return EOF;
    while ( !( _porta & BUSY ) ) ;      /* BUSYM܂ŃEGCg */
    _portb = c;
    for ( i = 0 ; i < 10 ; i++ ) ;      /* EGCg */
    _porta = RESET;                     /* STROBEZbg */
    for ( i = 0 ; i < 10 ; i++ ) ;      /* EGCg */
    _porta = RESET | STROBE;            /* STROBE */
    while ( _porta & ACK ) ;            /* ACK҂ */
    if ( _porta & FAULT )
        return EOF;
    else
        return TRUE;
}



/*******************************************************************************
*
* t`qs֐AZgjNXo͑u֐
*
* Copyright 1995, MITSUBISHI ELECTRIC CORPORATION
* AND MITSUBISHI ELECTRIC SEMICONDUCTOR SOFTWARE CORPORATION
* All Rights Reserved.
*
*******************************************************************************/
