#include    <stdio.h>
#include    <stdlib.h>
#include "sed1375.h"
#include "sfr62.h"

#define SET_REG(adr, value)  SED1375REGBASE[adr] = value
#define READ_REG(adr )       SED1375REGBASE[adr] 

#define ID_137X 0x24					 /* SED1375 device ID           */
#define MEM_SIZE 0x14000				 /* 80kb display buffer			*/
#define MAX_MEM_SIZE 0x14000			 /* 80kb display buffer		    */
#define PIC_OFFSET 0x20000				 /* picture address				*/
#define PIC_OFFSET2 0x20000				 /* picture address	2			*/

#pragma ADDRESS SED1375REGBASE 05FFE0H
unsigned char far SED1375REGBASE[0x14000];

#pragma ADDRESS SED137x_RAM 040000H
unsigned char far SED137x_RAM[];


void printf_LCD( unsigned char * teststring) {
unsigned int i;
   while ( (i-- > 0) && (*teststring != 0)) {
   }
}

void far inc_NVP(){
unsigned char temp;
  /* Register 0Ah vertical non-display period */
    temp = READ_REG(REG_VERT_NONDISP_PERIOD);
    temp++;
    if ( temp < 2 ) temp = 2;
    SET_REG(REG_VERT_NONDISP_PERIOD, temp);
     printf(" \rNVP:%02d", (int)temp);
}

void far dec_NVP(){
unsigned char temp;
    /* Register 0Ah vertical non-display period */
    temp = READ_REG(REG_VERT_NONDISP_PERIOD);
    temp--;
    if ( temp < 2 ) temp = 0xff;
    SET_REG(REG_VERT_NONDISP_PERIOD, temp);
	printf(" \rNVP:%02d", (int)temp);
}
void far inc_NHP(){
unsigned char temp;
    /* Register 0Ah vertical non-display period */
    temp = READ_REG(REG_HORZ_NONDISP_PERIOD);
    temp++;
    if ( temp < 2 ) temp = 2;
    SET_REG(REG_HORZ_NONDISP_PERIOD, temp);
	printf(" \rNHP:%02d", (int)temp);
}

void far dec_NHP(){
unsigned char temp;
    /* Register 0Ah vertical non-display period */
    temp = READ_REG(REG_HORZ_NONDISP_PERIOD);
    temp--;
    if ( temp < 2 ) temp = 0xff;
    SET_REG(REG_HORZ_NONDISP_PERIOD, temp);
	printf(" \rNHP:%02d", (int)temp);
}

void far set_register(unsigned char reg_num, unsigned char reg_val){
   SET_REG(reg_num, reg_val);
   reg_val = READ_REG(reg_num );
   printf("\nReg%02x: %02x", reg_num, reg_val);
}

void far read_register(unsigned char reg_num){
int dummy2;
   dummy2 = READ_REG (reg_num);
   printf("Reg%02x: %02x", (int)reg_num, dummy2);
}

void far show_register(){
int dummy2,i;
   printf("\nSED137x Register contents\n   ");
   for (i=0; i <= 0x0f; i++) {
     printf(" %02X", i);
   }
   printf("\n00:");
   for (i=0; i < 0x1d; i++) {
      dummy2 = READ_REG (i);    
      printf(" %02x", dummy2);
 	  if (i == 0x0f) printf("\n01:");
   }
}

void far show_LUT(){
int dummy2,i,i2;
unsigned char value, lutmax; 
   printf("\nSED137x LUT contents\n   ");
   value = READ_REG (REG_MODE_REGISTER_1);
   switch (value & 0xc0){
     case 0x00: lutmax = 0x01;
	            break;
     case 0x40: lutmax = 0x03;
	            break;
     case 0x80: lutmax = 0x0f;
	            break;
     case 0xc0: lutmax = 0xff;
	            break;
     default  : lutmax = 0x0f;
	            break;
   }

   for (i=0; i <= lutmax; i++) {
     SET_REG(REG_LUT_ADDR, i);
     printf("\n%02X: ", i);
	 for (i2=0; i2 <3; i2++) {
	     dummy2 = READ_REG(REG_LUT_DATA);
	     printf(" %02x", dummy2);
	 }
     if (lutmax > 0x0f) {
	    if ((i % 0x0f) == 0 ) {
                if (27 == getchar()) break;
	    }
   	 }
   }
   printf("\n");
}

void far edit_LUT(){
unsigned char far * pointer;
unsigned char far instring[20];
int dummy2, i1, i2, sbc, cnt;
unsigned char i[4], x;
char break_flag;

   show_LUT();
   break_flag = 0;
   do {
     printf("\nLUT entry to change or <ESC>:");
     if (1 != scanf("%x", &i1)) {
	   break_flag = 1;
	 }
	 else {
       printf("\n%02X: ", i1);
       SET_REG(REG_LUT_ADDR,i1);
       for (i2=0; i2 <3; i2++) {
	     dummy2 = READ_REG(REG_LUT_DATA);
	     printf(" %02x", dummy2);
       }
       printf("\nnew values:\n");
	printf("\nLN: RR GG BB<space><CR>");
       printf("\n%02X: ", i1);
       SET_REG(REG_LUT_ADDR,i1);
	gets(&instring[0]);
       pointer  = &instring[1];

       i[0] = 0;
       i[1] = 0;
       i[2] = 0;
	sbc  = 1;
	cnt  = 1;
	x    = 0;
	while ( (*pointer != 0) && (*pointer != '\n') ) {
	  sbc++;
	  if ( *pointer == ' ' ) {
	     *pointer = 0;
	     i[x]  = strtol(&instring[cnt], NULL, 16);
	     x++;
	     cnt = sbc;
   	  } 
	  pointer++;
  	}

       SET_REG(REG_LUT_DATA,i[0]);
       SET_REG(REG_LUT_DATA,i[1]);
       SET_REG(REG_LUT_DATA,i[2]);

       SET_REG(REG_LUT_ADDR,i1);
	i[0] = READ_REG(REG_LUT_DATA);
	i[1] = READ_REG(REG_LUT_DATA);
	i[2] = READ_REG(REG_LUT_DATA);
       printf("\nValue changed to: \n%02X: %02X %02X %02X ", i1, i[0], i[1], i[2]);
     }
   }
   while (!break_flag);
   show_LUT();
}