/* this handle is assigned in sect30.inc 										*/
#include "sed1375.h"
#include "ads7843.h"
#include "sfr62.h"
#include <stdio.h>

#pragma INTERRUPT  ads7843_penirq	/* Declares interrupt handler for ADS7843 Pen IRQ connectet to INT0 	*/
unsigned int xpos;
unsigned int ypos;

unsigned int x_calfactor10 = 3200/(110);
unsigned int y_calfactor10 = 2400/(110);

char  new_touch_value = 0;

/**** Interrupt Routine int0 ** ADS7843 PENIRQ interrupt service routine *************************************/
void far ads7843_penirq(void)
{
     new_touch_value = XY_pos_rd( &xpos, &ypos); 
     return;
}

void clock_out(unsigned char controll) {
unsigned char i;
  ADS_CS  = 0;			/* enable ADS7843 */ 
  ir_s3ic = 0;
  s3trr = controll;
  while ( !ir_s3ic );
}

void far ADS_init(){
   
   pd8_2    = 0;	/* set ADS PENIRQ to input		  */
   pd8_3    = 0;        /* set ADS BUSY to input             */
   pd8_4    = 1;	/* set ADS CS to output		  */
   pd9_0    = 1;	/* set ADS clock to output  	  */
   pd9_1    = 0;        /* set ADS DOUT to input   	  	  */
   pd9_2    = 1;	/* set ADS DIN to output		  */

   prcr     = 0x0f;     /* enable smi register access        */

   smi0_s3c = 1;	/* system clock f/32 16MHz/32 = 500kHz*/
   smi1_s3c = 0;	/* system clock f/8 16MHz/32 = 500MHz */
   smi2_s3c = 0;	/* SIO3 Clock enabled                */
   smi3_s3c = 1;	/* sout3 enabled, SIO3 Clock enabled */
                        /* register bit 4 n/a 		  */
   smi5_s3c = 1;        /* Select MSB first                  */
   smi6_s3c = 1;        /* Sout3 internal clock select       */
   smi7_s3c = 0;        /* Sout3 initial value Low           */

   prcr     = 0x00;     /* disable smi register access       */

   s3brg    = 0x04;     /* devision factor for clock source  */
//   s3ic     = 0x01; /* enable SIO3 interrupt		  */

   ADS_CS   = 0;	/* enable ADS7843 			  */ 
   printf("\nInit ADS PEN_IRQ");
   seDrawText( 24, 0, "Init ADS PEN_IRQ", 0x0f, 0x00);

   XY_pos_rd( &xpos, &ypos);
   printf(" complete \n ");
   ifsr     =  0;
   int0ic= 0x05;	/* enable PEN_IRQ interrupt with Level 5	*/
 }


/*********************************************************************************************************/
/* read touch screen in 8bit mode   										*/
/* return coordinate by reference   										*/
/* return 1 if touch screen pressed 										*/
/* power down with IRQ enabled     										*/
/* X and Y value changed to addapt to fpc2-b-004-20-T connector						*/
/*********************************************************************************************************/
char far XY_pos_rd( unsigned int * xpos, unsigned int * ypos){
       *ypos = *xpos = 0;
       int0ic= 0x00;	   /* disable PEN_IRQ */

       /* get y coordinate 1st time */
       ir_s3ic  = 0;     /* reset pending SIO3 interrupt      */
       s3trr    =  S | READ_X | _8BitMode | Differential | PD_Off;
       while ( !ir_s3ic );
       ir_s3ic  = 0;     /* reset pending SIO3 interrupt      */
       s3trr    = 0x00;  /* send 0x00 to ADS		    */
       while ( !ir_s3ic );
       *ypos =  (unsigned int)s3trr;
       /* get y coordinate 2nd time*/
       ir_s3ic  = 0;     /* reset pending SIO3 interrupt      */
       s3trr    =  S | READ_X | _8BitMode | Differential | PD_Off;
       while ( !ir_s3ic );
       ir_s3ic  = 0;     /* reset pending SIO3 interrupt      */
       s3trr    = 0x00;  /* send 0x00 to ADS		    */
       while ( !ir_s3ic );
       *ypos =  (unsigned int)s3trr;

       /* get x coordinate 1st time*/
       ir_s3ic  = 0;      /* reset pending SIO3 interrupt      */
       s3trr    =  S | READ_Y | _8BitMode | Differential | PD_IRQenable;
       while ( !ir_s3ic );
       ir_s3ic  = 0;      /* reset pending SIO3 interrupt      */
       s3trr    =  0x00;  /* dummy instruction                 */
       while ( !ir_s3ic );
       *xpos =  (unsigned int)s3trr;
       ir_s3ic  = 0;      /* reset pending SIO3 interrupt      */
       s3trr    =  S | READ_Y | _8BitMode | Differential | PD_IRQenable;
       while ( !ir_s3ic );
       ir_s3ic  = 0;      /* reset pending SIO3 interrupt      */
       s3trr    =  0x00;  /* dummy instruction                 */
       while ( !ir_s3ic );
       *xpos =  (unsigned int)s3trr;
       ir_s3ic  = 0;      /* reset pending SIO3 interrupt      */
       s3trr    =  0x00;  /* dummy instruction                 */
       while ( !ir_s3ic );
       ir_s3ic  = 0;      /* reset pending SIO3 interrupt      */

       int0ic= 0x05;	 /* enable PEN_IRQ interrupt with Level 5	*/

       if ( (*xpos > 1 ) && (*ypos > 1)  ) {
         if (( (*xpos*x_calfactor10) <= 3200 ) ) {
           *xpos = (3200 - (*xpos * x_calfactor10)) / 10;
	 } else {
	   *xpos = 0;
	 }
         if (( (*ypos*y_calfactor10) <= 2400 ) ) {
           *ypos = (2400 - (*ypos * y_calfactor10)) / 10;
	 } else {
	   *ypos = 0;
	 }
	 return (1);
       } else {
	   return (0);
       }
}