/*
**===========================================================================
**  SED1375.H - 
**---------------------------------------------------------------------------
**
**  Created 2001, GTK SYSTEMS
**
**  All the defines and declarations needed to use SED1375 functions
**
**---------------------------------------------------------------------------
*/
#include "reg1375.h"
#define BITMAP_ID		0x4D42				/* 'BM' */
#define MONO 			0
#define COLOR 		1

typedef unsigned char  BYTE;
typedef unsigned short WORD;
typedef unsigned long  DWORD;
typedef unsigned int   UINT;
typedef          int   BOOL;

typedef BYTE       * LPBYTE;
typedef BYTE   far * HPBYTE;
typedef WORD       * LPWORD;
typedef WORD       * HPWORD;
typedef DWORD      * LPDWORD;
typedef DWORD      * HPDWORD;
typedef UINT       * LPUINT;

#ifndef LOBYTE
#define LOBYTE(w)    ((BYTE)(w))
#endif

#ifndef HIBYTE
#define HIBYTE(w)    ((BYTE)(((UINT)(w) >> 8) & 0xFF))
#endif

#ifndef LOWORD
#define LOWORD(l)    ((WORD)(DWORD)(l))
#endif

#ifndef HIWORD
#define HIWORD(l)    ((WORD)((((DWORD)(l)) >> 16) & 0xFFFF))
#endif

#ifndef TRUE
#define TRUE   1
#endif

#ifndef FALSE
#define FALSE  0
#endif

#define OFF 0
#define ON  1

#define	SUCCEED	0
#define	FAIL		1

typedef struct tagRGB
{
	BYTE Red;
	BYTE Green;
	BYTE Blue;
} RGB;

typedef struct tagRGBQUAD
{
	BYTE rgbBlue;
	BYTE rgbGreen;
	BYTE rgbRed;
	BYTE rgbReserved;
} RGBQUAD;

typedef struct tagBITMAPFILEHEADER
{
	WORD	bfType;
	DWORD	bfSize;
	WORD	bfReserved1;
	WORD	bfReserved2;
	DWORD	bfOffBits;
} BITMAPFILEHEADER;

typedef BITMAPFILEHEADER      *PBITMAPFILEHEADER;

typedef BITMAPFILEHEADER  far *LPBITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER
{
	DWORD	biSize;
	DWORD	biWidth;
	DWORD	biHeight;
	WORD	biPlanes;
	WORD	biBitCount;

	DWORD	biCompression;
	DWORD	biSizeImage;
	DWORD	biXPelsPerMeter;
	DWORD	biYPelsPerMeter;
	DWORD	biClrUsed;
	DWORD	biClrImportant;
} BITMAPINFOHEADER;

/* constants for the biCompression field */
#define BI_RGB      0L
#define BI_RLE8     1L
#define BI_RLE4     2L

enum
{
	ERR_OK = 0,					/* No error, call was successful. */
	ERR_FAILED,					/* General purpose failure.       */

	ERR_UNKNOWN_DEVICE,			/* */
	ERR_INVALID_PARAMETER,		/* Function was called with invalid parameter. */
	ERR_HAL_BAD_ARG,
	ERR_TOOMANY_DEVS,

	ERR_FAILED_VXD_OPEN,		/* HAL was unable to locate/load SED13XX.VXD */
	ERR_IOCTL_ERROR				/* An error occurred calling an IOCTL function. */
};


typedef struct tagBITMAPINFO
{ 
	BITMAPINFOHEADER	bmiHeader;
	RGBQUAD		bmiColors[1];
} BITMAPINFO;

typedef BITMAPINFO     *PBITMAPINFO;
#if defined INTEL_16BIT
typedef BITMAPINFO far *LPBITMAPINFO;
#else
typedef BITMAPINFO     *LPBITMAPINFO;
#endif


/*-------------------------------------------------------------------------*/

void DisplayCopyright();
void DisplayUsage();

int ShowCompressed  ( int fh, int DstX, int DstY, int ImgH, int ImgW, int Bpp );
int ShowUncompressed( int fh, int DstX, int DstY, int ImgH, int ImgW, int Bpp );
void Translate( LPBYTE pImgBuf, int LineWidth, int Bpp );
int  LineBlt( LPBYTE pImgBuf, int nImgWidth, int nDstX, int nDstY, int nDstWidth, int Bpp );
void Delay( int nDelayTime );

unsigned char far init_sed1375(void);
void far draw_bar(unsigned char color_num, unsigned int pos, unsigned int height, unsigned int width);
void far clear_display(void);
void far set_display(unsigned char color_num);
void far putbmp ( unsigned char  invert, unsigned char far * bmpd, unsigned int x , unsigned int y, int ImgW, int Bpp  ); 
void far inc_NVP();
void far dec_NVP(void);
void far inc_NHP(void);
void far dec_NHP(void);
void far set_register(unsigned char reg_num, unsigned char reg_val);
void far read_register(unsigned char reg_num);
void far show_register();
void far edit_LUT(void);
void far show_LUT(void);
void far show_ram(void);
unsigned char far ShowBMP( unsigned char far * FileName );
unsigned char far ShowBMPat( unsigned char far * PicName, int nDstX, int nDstY);

void seDrawText( int Row, int Col, unsigned char far *pStr, int fg, int bg );
int far seGetBitsPerPixel(int *pBitsPerPixel );
int seGetBytesPerScanline(int *pnBytes );

void draw_circle(BYTE color_circ, BYTE color_fill, BYTE fill_style, WORD x_pos, WORD y_pos, BYTE radius);
void set_Displaymode ( unsigned char mode );
