/**************************************************************************/
/**MITSUBISHI**MITSUBISHI**MITSUBISHI**MITSUBISHI**MITSUBISHI**MITSUBISHI**/
/**************************************************************************/
/**************************************************************************/
/*  DISCLAIMER:                                                           */
/*  We (MITSUBISHI ELECTRIC B.V.) do not warrant that the Software is     */
/*  free from claims by a third party of copyright, patent, trademark,    */
/*  trade secret or any other intellectual property infringement.         */
/*                                                                        */
/*  Under no circumstances are we liable for any of the following:        */
/*                                                                        */
/*  1. third-party claims against you for losses or damages;              */
/*  2. loss of, or damage to, your records or data; or                    */
/*  3. economic consequential damages (including lost profits or          */
/*     savings) or incidental damages, even if we are informed of         */
/*     their possibility.                                                 */
/*                                                                        */
/*  We do not warrant uninterrupted or error free operation of the        */
/*  Software. We have no obligation to provide service, defect            */
/*  correction, or any maintenance for the Software. We have no           */
/*  obligation to supply any Software updates or enhancements to you      */
/*  even if such are or later become available.                           */
/*                                                                        */
/*  IF YOU DOWNLOAD OR USE THIS SOFTWARE YOU AGREE TO THESE TERMS.        */
/*                                                                        */
/*  THERE ARE NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING THE            */
/*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A               */
/*  PARTICULAR PURPOSE.                                                   */
/**************************************************************************/
/**************************************************************************/
/*                                                                        */
/*       Internal register addresses for the M3062                        */
/*                                                                        */
/*       Name:        SFR_3062.H                                          */
/*       Date  :      04.04.1997                                          */
/*       Author:      GA/ST                                               */
/*       Change:                                                          */
/*               15.01.99  CA  Existing headerfile has been  extended     */
/*                             for usage with M16C62                      */
/*                                                                        */
/**************************************************************************/


/************************  Processor Registers  ***************************/
#ifdef NC30                    // if Mitsubishi NC30 compiler is used

#define fct_loc_1    far

#pragma ADDRESS PM0    004h   // Processor Mode Register 0
#pragma ADDRESS PM1    005h   // Processor Mode Register 1
#pragma ADDRESS CM0    006h   // System clock control register 0 
#pragma ADDRESS CM1    007h   // System clock control register 1 
#pragma ADDRESS CM     006h   // System clock control register   
#pragma ADDRESS CSR    008h   // Chip select control register    

/************************  Watchdog Timer  ********************************/

#pragma ADDRESS WDTS   00Eh   // Watchdog timer start register   
#pragma ADDRESS WDC    00Fh   // Watchdog timer control register 

/************************  Interrupt Control Register  ********************/

#pragma ADDRESS AIER   009h   // Address match interrupt enable           
#pragma ADDRESS PRCR   00Ah   // Protect register                         
#pragma ADDRESS RMAD00 010h   // Address match interrupt register 0 (low) 
#pragma ADDRESS RMAD01 011h   // Address match interrupt register 0 (mid) 
#pragma ADDRESS RMAD02 012h   // Address match interrupt register 0 (high)
#pragma ADDRESS RMAD10 014h   // Address match interrupt register 1 (low) 
#pragma ADDRESS RMAD11 015h   // Address match interrupt register 1 (mid) 
#pragma ADDRESS RMAD12 016h   // Address match interrupt register 1 (high)
#pragma ADDRESS INT3IC 044h   // INT3 interrupt control register
#pragma ADDRESS TB5IC  045h   // Timer B5 interrupt control register
#pragma ADDRESS TB4IC  046h   // Timer B4 interrupt control register
#pragma ADDRESS TB3IC  047h   // Timer B3 interrupt control register
#pragma ADDRESS S4IC   048h   // SI/O4 interrupt control register
#pragma ADDRESS INT5IC 048h   // INT5  interrupt control register
#pragma ADDRESS S3IC   049h   // SI/03 interrupt control register
#pragma ADDRESS INT4IC 049h   // INT4  interrupt control register 
#pragma ADDRESS BCNIC  04Ah   // Bus collision detection interrupt control register

#pragma ADDRESS DMA0IC 04Bh   // DMA0 interrupt control register          
#pragma ADDRESS DMA1IC 04Ch   // DMA1 interrupt control register          
#pragma ADDRESS KUPIC  04Dh   // Key input interrupt control register
#pragma ADDRESS ADIC   04Eh   // A-D converter interrupt control register
#pragma ADDRESS S2TIC  04Fh   // UART2 transmit interrupt control register
#pragma ADDRESS S2RIC  050h   // UART2 receive interrupt control register
#pragma ADDRESS S0TIC  051h   // UART0 transmit interrupt control register
#pragma ADDRESS S0RIC  052h   // UART0 receive interrupt control register 
#pragma ADDRESS S1TIC  053h   // UART1 transmit interrupt control register
#pragma ADDRESS S1RIC  054h   // UART1 receive interrupt control register 
#pragma ADDRESS TA0IC  055h   // Timer A0 interrupt control register      
#pragma ADDRESS TA1IC  056h   // Timer A1 interrupt control register      
#pragma ADDRESS TA2IC  057h   // Timer A2 interrupt control register      
#pragma ADDRESS TA3IC  058h   // Timer A3 interrupt control register      
#pragma ADDRESS TA4IC  059h   // Timer A4 interrupt control register      
#pragma ADDRESS TB0IC  05Ah   // Timer B0 interrupt control register      
#pragma ADDRESS TB1IC  05Bh   // Timer B1 interrupt control register      
#pragma ADDRESS TB2IC  05Ch   // Timer B2 interrupt control register      
#pragma ADDRESS INT0IC 05Dh   // Interrupt 0 interrupt control register   
#pragma ADDRESS INT1IC 05Eh   // Interrupt 1 interrupt control register   
#pragma ADDRESS INT2IC 05Fh   // Interrupt 2 interrupt control register   

/************************  DMA Registers  *********************************/

#pragma ADDRESS SAR00  020h   // DMA0 source pointer (low)        
#pragma ADDRESS SAR01  021h   // DMA0 source pointer (mid)        
#pragma ADDRESS SAR02  022h   // DMA0 source pointer (high)       
#pragma ADDRESS DAR00  024h   // DMA0 destination pointer (low)   
#pragma ADDRESS DAR01  025h   // DMA0 destination pointer (mid)   
#pragma ADDRESS DAR02  026h   // DMA0 destination pointer (high)  
#pragma ADDRESS TCR00  028h   // DMA0 transfer counter (low)      
#pragma ADDRESS TCR01  029h   // DMA0 transfer counter (high)     
#pragma ADDRESS TCR0   028h   // DMA0 transfer counter            
#pragma ADDRESS DM0CON 02Ch   // DMA0 control register            
                       
#pragma ADDRESS SAR10  030h   // DMA1 source pointer (low)        
#pragma ADDRESS SAR11  031h   // DMA1 source pointer (mid)        
#pragma ADDRESS SAR12  032h   // DMA1 source pointer (high)       
#pragma ADDRESS DAR10  034h   // DMA1 destination pointer (low)   
#pragma ADDRESS DAR11  035h   // DMA1 destination pointer (mid)   
#pragma ADDRESS DAR12  036h   // DMA1 destination pointer (high)  
#pragma ADDRESS TCR10  038h   // DMA1 transfer counter (low)      
#pragma ADDRESS TCR11  039h   // DMA1 transfer counter (high)     
#pragma ADDRESS TCR1   038h   // DMA1 transfer counter            
#pragma ADDRESS DM1CON 03Ch   // DMA1 control register            
                       
#pragma ADDRESS DM0SL  3B8h   // DMA0 cause selection  
#pragma ADDRESS DM1SL  3BAh   // DMA1 cause selection  

/************************  Timer Registers  *******************************/

#pragma ADDRESS TABSR  380h   // Timer A/B count start flags   
#pragma ADDRESS CPSRF  381h   // Clock prescaler reset flag    
#pragma ADDRESS ONSF   382h   // One-shot start flagl          
#pragma ADDRESS TRGSR  383h   // Trigger select register       
#pragma ADDRESS UDF    384h   // Up- down-count selection flag 
                       
#pragma ADDRESS TA0L   386h   // Timer A0 (low byte)  
#pragma ADDRESS TA0H   387h   // Timer A0 (high byte) 
#pragma ADDRESS TA0    386h   // Timer A0             
#pragma ADDRESS TA1L   388h   // Timer A1 (low byte)  
#pragma ADDRESS TA1H   389h   // Timer A1 (high byte) 
#pragma ADDRESS TA1    388h   // Timer A1             
#pragma ADDRESS TA2L   38Ah   // Timer A2 (low byte)  
#pragma ADDRESS TA2H   38Bh   // Timer A2 (high byte) 
#pragma ADDRESS TA2    38Ah   // Timer A2             
#pragma ADDRESS TA3L   38Ch   // Timer A3 (low byte)  
#pragma ADDRESS TA3H   38Dh   // Timer A3 (high byte) 
#pragma ADDRESS TA3    38Ch   // Timer A3             
#pragma ADDRESS TA4L   38Eh   // Timer A4 (low byte)  
#pragma ADDRESS TA4H   38Fh   // Timer A4 (high byte) 
#pragma ADDRESS TA4    38Eh   // Timer A4             
#pragma ADDRESS TB0L   390h   // Timer B0 (low byte)  
#pragma ADDRESS TB0H   391h   // Timer B0 (high byte) 
#pragma ADDRESS TB0    390h   // Timer B0             
#pragma ADDRESS TB1L   392h   // Timer B1 (low byte)  
#pragma ADDRESS TB1H   393h   // Timer B1 (high byte) 
#pragma ADDRESS TB1    392h   // Timer B1             
#pragma ADDRESS TB2L   394h   // Timer B2 (low byte)  
#pragma ADDRESS TB2H   395h   // Timer B2 (high byte) 
#pragma ADDRESS TB2    394h   // Timer B2             
                       


#pragma ADDRESS TA0MR  396h   // Timer A0 mode register  
#pragma ADDRESS TA1MR  397h   // Timer A1 mode register  
#pragma ADDRESS TA2MR  398h   // Timer A2 mode register  
#pragma ADDRESS TA3MR  399h   // Timer A3 mode register  
#pragma ADDRESS TA4MR  39Ah   // Timer A4 mode register  
#pragma ADDRESS TB0MR  39Bh   // Timer B0 mode register  
#pragma ADDRESS TB1MR  39Ch   // Timer B1 mode register  
#pragma ADDRESS TB2MR  39Dh   // Timer B2 mode register  


/******************** More Timer Registers for M16C62 *********************/

#pragma ADDRESS TBSR   340h   // Timer B3,4,5 count start flag
#pragma ADDRESS TB3L   350h   // Timer B3 (low byte)
#pragma ADDRESS TB3H   351h   // Timer B3 (high byte)
#pragma ADDRESS TB3    350h   // Timer B3
#pragma ADDRESS TB4L   352h   // Timer B4 (low byte)
#pragma ADDRESS TB4H   353h   // Timer B4 (low byte)
#pragma ADDRESS TB4    352h   // Timer B4
#pragma ADDRESS TB5L   354h   // Timer B5 (low byte)
#pragma ADDRESS TB5H   355h   // Timer B5 (high byte)
#pragma ADDRESS TB5    354h   // Timer B5 


#pragma ADDRESS TB3MR  35Bh   // Timer B3 mode register
#pragma ADDRESS TB4MR  35Ch   // Timer B4 mode register
#pragma ADDRESS TB5MR  35Dh   // Timer B5 mode register

#pragma ADDRESS TA11L   342h   // Timer A1-1 register  (low byte)
#pragma ADDRESS TA11H   343h   // Timer A1-1 register  (high byte)
#pragma ADDRESS TA11    342h   // Timer A1-1 register
#pragma ADDRESS TA21L   344h   // Timer A2-1 register  (low byte)
#pragma ADDRESS TA21H   345h   // Timer A2-1 register  (high byte)
#pragma ADDRESS TA21    344h   // Timer A2-1 register
#pragma ADDRESS TA41L   346h   // Timer A4-1 register  (low byte)
#pragma ADDRESS TA41H   347h   // Timer A4-1 register  (high byte)
#pragma ADDRESS TA41    346h   // Timer A4-1 register  

#pragma ADDRESS INVC0   348h   // Three-phase control register 0
#pragma ADDRESS INVC1   349h   // Three-phase control register 1
#pragma ADDRESS IDB0    34Ah   // Three-phase output buffer register0
#pragma ADDRESS IDB1    34Bh   // Three-phase output buffer register1
#pragma ADDRESS DTT     34Ch   // Dead time timer
#pragma ADDRESS ICTB2 	34Dh   // Timer B2 interrupt occurrence frequency set counter
/************************  UART Registers  ********************************/

#pragma ADDRESS U0MR   3A0h   // UART 0 mode register                
#pragma ADDRESS U0BRG  3A1h   // UART 0 baud rate generator          
#pragma ADDRESS U0TBL  3A2h   // UART 0 transmit buffer (low byte)   
#pragma ADDRESS U0TBH  3A3h   // UART 0 transmit buffer (high byte)  
#pragma ADDRESS U0TB   3A2h   // UART 0 transmit buffer              
#pragma ADDRESS U0C0   3A4h   // UART 0 control register 0           
#pragma ADDRESS U0C1   3A5h   // UART 0 control register 1           
#pragma ADDRESS U0C    3A4h   // UART 0 control register             
#pragma ADDRESS U0RBL  3A6h   // UART 0 receive buffer (low byte)    
#pragma ADDRESS U0RBH  3A7h   // UART 0 receive buffer (high byte)   
#pragma ADDRESS U0RB   3A6h   // UART 0 receive buffer               
                       
#pragma ADDRESS U1MR   3A8h   // UART 1 mode register                
#pragma ADDRESS U1BRG  3A9h   // UART 1 baud rate generator          
#pragma ADDRESS U1TBL  3AAh   // UART 1 transmit buffer (low byte)   
#pragma ADDRESS U1TBH  3ABh   // UART 1 transmit buffer (high byte)  
#pragma ADDRESS U1TB   3AAh   // UART 1 transmit buffer              
#pragma ADDRESS U1C0   3ACh   // UART 1 control register 0           
#pragma ADDRESS U1C1   3ADh   // UART 1 control register 1           
#pragma ADDRESS U1C    3ACh   // UART 1 control register             
#pragma ADDRESS U1RBL  3AEh   // UART 1 receive buffer (low byte)    
#pragma ADDRESS U1RBH  3AFh   // UART 1 receive buffer (high byte)   
#pragma ADDRESS U1RB   3AEh   // UART 1 receive buffer               
#pragma ADDRESS UCON   3B0h   // UART control register 2 

#pragma ADDRESS IFSR   35Fh   // Interrupt cause select register
#pragma ADDRESS S3TRR  360h   // SI/O3 transmit/receive register
#pragma ADDRESS S3C    362h   // SI/O3 control register
#pragma ADDRESS S3BRG  363h   // SI/O3 bit rate generator
#pragma ADDRESS S4TRR  364h   // SI/O4 transmit/receive register
#pragma ADDRESS S4C    366h   // SI/O4 control register
#pragma ADDRESS S4BRG  367h   // SI/O4 bit rate generator

#pragma ADDRESS U2SMR2 376h   // UART2 special mode register 2
#pragma ADDRESS U2SMR  377h   // UART2 special mode register
#pragma ADDRESS U2MR   378h   // UART2 transmit/receive mode register
#pragma ADDRESS U2BRG  379h   // UART2 bit rate generator
#pragma ADDRESS U2TBL  37Ah   // UART2 transmit buffer register (low byte)
#pragma ADDRESS U2TBH  37Bh   // UART2 transmit buffer register (high byte)
#pragma ADDRESS U2TB   37Ah   // UART2 transmit buffer register
#pragma ADDRESS U2C0   37Ch   // UART2 transmit/receive control register 0
#pragma ADDRESS U2C1   37Dh   // UART2 transmit/receive control register 1
#pragma ADDRESS U2RBL  37Eh   // UART2 receive buffer register (low byte)
#pragma ADDRESS U2RBH  37Fh   // UART2 receive buffer register (high byte)
#pragma ADDRESS U2RB   37Eh   // UART2 receive buffer register
/************************  CRC register  **********************************/

#pragma ADDRESS CRCDL  3BCh   // CRC data register (low byte)  
#pragma ADDRESS CRCDH  3BDh   // CRC data register (high byte) 
#pragma ADDRESS CRCD   3BCh   // CRC data register             
#pragma ADDRESS CRCIN  3BEh   // CRC input register            

/************************  A/D Converter  *********************************/

#pragma ADDRESS AD0L   3C0h   // A/D register 0 (low byte)   
#pragma ADDRESS AD0H   3C1h   // A/D register 0 (high byte)  
#pragma ADDRESS AD0    3C0h   // A/D register 0              
#pragma ADDRESS AD1L   3C2h   // A/D register 1 (low byte)   
#pragma ADDRESS AD1H   3C3h   // A/D register 1 (high byte)  
#pragma ADDRESS AD1    3C2h   // A/D register 1              
#pragma ADDRESS AD2L   3C4h   // A/D register 2 (low byte)   
#pragma ADDRESS AD2H   3C5h   // A/D register 2 (high byte)  
#pragma ADDRESS AD2    3C4h   // A/D register 2              
#pragma ADDRESS AD3L   3C6h   // A/D register 3 (low byte)   
#pragma ADDRESS AD3H   3C7h   // A/D register 3 (high byte)  
#pragma ADDRESS AD3    3C6h   // A/D register 3              
#pragma ADDRESS AD4L   3C8h   // A/D register 4 (low byte)   
#pragma ADDRESS AD4H   3C9h   // A/D register 4 (high byte)  
#pragma ADDRESS AD4    3C8h   // A/D register 4              
#pragma ADDRESS AD5L   3CAh   // A/D register 5 (low byte)   
#pragma ADDRESS AD5H   3CBh   // A/D register 5 (high byte)  
#pragma ADDRESS AD5    3CAh   // A/D register 5              
#pragma ADDRESS AD6L   3CCh   // A/D register 6 (low byte)   
#pragma ADDRESS AD6H   3CDh   // A/D register 6 (high byte)  
#pragma ADDRESS AD6    3CCh   // A/D register 6              
#pragma ADDRESS AD7L   3CEh   // A/D register 7 (low byte)   
#pragma ADDRESS AD7H   3CFh   // A/D register 7 (high byte)  
#pragma ADDRESS AD7    3CEh   // A/D register 7              
                       
#pragma ADDRESS ADCON2 3D4h   // A/D control register 2
#pragma ADDRESS ADCON0 3D6h   // A/D control register 0  
#pragma ADDRESS ADCON1 3D7h   // A/D control register 1  
#pragma ADDRESS ADCON  3D6h   // A/D control register    

/************************  D-A Converter  *********************************/

#pragma ADDRESS DA0    3D8h   // D-A register 0        
#pragma ADDRESS DA1    3DAh   // D-A register 1        
#pragma ADDRESS DACON  3DCh   // D-A control register  

/************************  Port Registers  ********************************/

#pragma ADDRESS P0     3E0h   // Port P0 register                   
#pragma ADDRESS P1     3E1h   // Port P1 register                   
#pragma ADDRESS P01    3E0h   // Port P0 and P1 register            
#pragma ADDRESS PD0    3E2h   // Port P0 direction register         
#pragma ADDRESS PD1    3E3h   // Port P1 direction register         
#pragma ADDRESS PD01   3E2h   // Port P0 and P1 direction register  
#pragma ADDRESS P2     3E4h   // Port P2 register                   
#pragma ADDRESS P3     3E5h   // Port P3 register                   
#pragma ADDRESS P23    3E4h   // Port P2 and P3 register            
#pragma ADDRESS PD2    3E6h   // Port P2 direction register         
#pragma ADDRESS PD3    3E7h   // Port P3 direction register         
#pragma ADDRESS PD23   3E6h   // Port P2 and P3 direction register  
#pragma ADDRESS P4     3E8h   // Port P4 register                   
#pragma ADDRESS P5     3E9h   // Port P5 register                   
#pragma ADDRESS P45    3E8h   // Port P4 and P5 register            
#pragma ADDRESS PD4    3EAh   // Port P4 direction register         
#pragma ADDRESS PD5    3EBh   // Port P5 direction register         
#pragma ADDRESS PD45   3EAh   // Port P4 and P5 direction register  
#pragma ADDRESS P6     3ECh   // Port P6 register                   
#pragma ADDRESS P7     3EDh   // Port P7 register                   
#pragma ADDRESS P67    3ECh   // Port P6 and P7 register            
#pragma ADDRESS PD6    3EEh   // Port P6 direction register         
#pragma ADDRESS PD7    3EFh   // Port P7 direction register         
#pragma ADDRESS PD67   3EEh   // Port P6 and P7 direction register  
#pragma ADDRESS P8     3F0h   // Port P8 register                   
#pragma ADDRESS P9     3F1h   // Port P9 register                   
#pragma ADDRESS P89    3F0h   // Port P8 and P9 register            
#pragma ADDRESS PD8    3F2h   // Port P8 direction register         
#pragma ADDRESS PD9    3F3h   // Port P9 direction register         
#pragma ADDRESS PD89   3F2h   // Port P8 and P9 direction register  
#pragma ADDRESS P10    3F4h   // Port P10 register                  
#pragma ADDRESS PD10   3F6h   // Port P10 direction register        
               
#pragma ADDRESS PUR0   3FCh   // Pull-up register 0                 
#pragma ADDRESS PUR1   3FDh   // Pull-up register 1                 
#pragma ADDRESS PUR2   3FEh   // Pull-up register 2                 
#pragma ADDRESS PCR    3FFh   // Port control register
/************************  System setting  ********************************/
unsigned char PM0, PM1, CM0, CM1, CSR;
unsigned int CM;

/************************  Watchdog Timer  ********************************/

unsigned char WDTS, WDC;

/************************  Interrupt Control Register  ********************/
unsigned char AIER, PRCR, RMAD00, RMAD01, RMAD02, RMAD10, RMAD11, RMAD12;
unsigned char DMA0IC, DMA1IC, KUPIC, ADIC, S0TIC, S0RIC, S1TIC, S1RIC, S2TIC, S2RIC;
unsigned char TA0IC, TA1IC, TA2IC, TA3IC, TA4IC, TA5IC, TB0IC, TB1IC, TB2IC;
unsigned char TB3IC, TB4IC, TB5IC ;
unsigned char INT0IC, INT1IC, INT2IC, INT3IC, INT4IC, INT5IC;
unsigned char S4IC, S3IC, BCNIC;

/************************  DMA Registers  *********************************/
unsigned char SAR00, SAR01, SAR02, DAR00, DAR01, DAR02, TCR00, TCR01, DM0CON;
unsigned int TCR0;
unsigned char SAR10, SAR11, SAR12, DAR10, DAR11, DAR12, TCR10, TCR11, DM1CON;
unsigned int TCR1;
unsigned char DM0SL, DM1SL;

/************************  Timer Registers  *******************************/
unsigned char TABSR, CPSRF, ONSF, TRGSR,UDF;
unsigned char TA0L, TA0H, TA1L, TA1H, TA2L, TA2H, TA3L, TA3H, TA4L, TA4H;
unsigned char TB0L, TB0H, TB1L, TB1H, TB2L, TB2H;
unsigned int TA0, TA1, TA2, TA3, TA4, TB0, TB1, TB2;
unsigned char TA0MR, TA1MR, TA2MR, TA3MR, TA4MR, TB0MR, TB1MR, TB2MR;

/******************** More Timer Registers for M16C62 *********************/

unsigned char TB3L, TB3H, TB4L, TB4H, TB5L, TB5H, TA11L, TA11H, TA21L, TA21H;
unsigned char TA41L, TA41H ;
unsigned int  TB3, TB4, TB5, TA11, TA21, TA41 ;
unsigned char TB3MR, TB4MR, TB5MR ;
unsigned char TBSR ; 
unsigned char INVC0, INVC1, IDB0, IDB1, DTT, ICTB2;

/************************  UART Registers  ********************************/
unsigned char U0MR, U0BRG, U0TBL, U0TBH, U0C0, U0C1, U0RBL, U0RBH;
unsigned int  U0TB, U0C, U0RB;
unsigned char U1MR, U1BRG, U1TBL, U1TBH, U1C0, U1C1, U1RBL, U1RBH;
unsigned int  U1TB, U1C, U1RB;
unsigned char IFSR, S3TRR, S3C, S3BRG, S4TRR, S4C, S4BRG;
unsigned char U2SMR2, U2SMR, U2MR, U2BRG, U2TBL, U2TBH, U2C0, U2C1, U2RBL, U2RBH;
unsigned int  U2TB, U2RB;
/************************  CRC register  **********************************/
unsigned char CRCDL, CRCDH, CRCIN;
unsigned int CRCD;

/************************  A/D Converter  *********************************/
unsigned char AD0L, AD0H, AD1L, AD1H, AD2L, AD2H, AD3L, AD3H;
unsigned char AD4L, AD4H, AD5L, AD5H, AD6L, AD6H, AD7L, AD7H;
unsigned int AD0, AD1, AD2, AD3, AD4, AD5, AD6, AD7;
unsigned char ADCON0, ADCON1, ADCON2;
unsigned int ADCON;            // consists of ADCON0 and ADCON1                                  

/************************  D-A Converter  *********************************/
unsigned char DA0, DA1, DA2, DACON;

/************************  Port Registers  ********************************/
unsigned char P0, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10;
unsigned char P01, P23, P45, P67, P89;
unsigned char PD0, PD1, PD2, PD3, PD4, PD5, PD6, PD7, PD8, PD9, PD10;
unsigned char PD01, PD23, PD45, PD67, PD89;
unsigned char PUR0, PUR1, PUR2, PCR;

#else 

#ifdef __IAR_SYSTEMS_ICC    // if IAR ICCM16C compiler is used

#define fct_loc_1    near

/********************  Processor Registers  ***********************/

sfrp PM         =       0x004;   /* Processor Mode Register */
sfr  PM0        =       0x004;   /* Processor Mode Register 0 */
sfr  PM1        =       0x005;   /* Processor Mode Register 1 */
sfr  CM0        =       0x006;   /* System clock control register 0 */
sfr  CM1        =       0x007;   /* System clock control register 1 */
sfrp CM         =       0x006;   /* System clock control register */
sfr  CSR        =       0x008;   /* Chip select control register */
                                  

/*******************  Watchdog Timer  ****************************/

sfr  WDTS       =       0x00E;   /* Watchdog timer start register */
sfr  WDC        =       0x00F;   /* Watchdog timer control register */


/*******************  Interrupt Control Register  ****************/

sfr  AIER       =       0x009;   /* Address match interrupt enable */
sfr  PRCR       =       0x00A;   /* Protect register */
sfr  RMAD00     =       0x010;   /* Address match interrupt register 0 (low) */
sfr  RMAD01     =       0x011;   /* Address match interrupt register 0 (mid) */
sfr  RMAD02     =       0x012;   /* Address match interrupt register 0 (high)*/
sfr  RMAD10     =       0x014;   /* Address match interrupt register 1 (low) */
sfr  RMAD11     =       0x015;   /* Address match interrupt register 1 (mid) */
sfr  RMAD12     =       0x016;   /* Address match interrupt register 1 (high)*/

sfr  INT3IC     =       0x044;   /* INT3 interrupt control register*/ 
sfr  TB5IC      =       0x045;   /* Timer B5 interrupt control register*/
sfr  TB4IC      =       0x046;   /* Timer B4 interrupt control register*/
sfr  TB3IC      =       0x047;   /* Timer B3 interrupt control register*/
sfr  S4IC       =       0x048;   /* SI/O4 interrupt control register*/
sfr  INT5IC     =       0x048;   /* INT5 interrupt control register */
sfr  S3IC       =       0x049;   /* SI/O3 interrupt control register*/
sfr  INT4IC     =       0x049;   /* INT4 interrupt control register*/ 
sfr  BCNIC      =       0x04A;   /* Bus collision detection interrupt control register*/
sfr  DMA0IC     =       0x04B;   /* DMA0 interrupt control register */
sfr  DMA1IC     =       0x04C;   /* DMA1 interrupt control register */
sfr  KUPIC      =       0x04D;   /* Key input interrupt control register */
sfr  ADIC       =       0x04E;   /* AD conversion interrupt control register*/
sfr  S2TIC      =       0x04F;   /* UART2 transmit interrupt control register*/
sfr  S2RIC      =       0x050;   /* UART2 receive interrupt control register */
sfr  S0TIC      =       0x051;   /* UART0 transmit interrupt control register*/
sfr  S0RIC      =       0x052;   /* UART0 receive interrupt control register */
sfr  S1TIC      =       0x053;   /* UART1 transmit interrupt control register*/
sfr  S1RIC      =       0x054;   /* UART1 receive interrupt control register */
sfr  TA0IC      =       0x055;   /* Timer A0 interrupt control register */
sfr  TA1IC      =       0x056;   /* Timer A1 interrupt control register */
sfr  TA2IC      =       0x057;   /* Timer A2 interrupt control register */
sfr  TA3IC      =       0x058;   /* Timer A3 interrupt control register */
sfr  TA4IC      =       0x059;   /* Timer A4 interrupt control register */
sfr  TB0IC      =       0x05A;   /* Timer B0 interrupt control register */
sfr  TB1IC      =       0x05B;   /* Timer B1 interrupt control register */
sfr  TB2IC      =       0x05C;   /* Timer B2 interrupt control register */
sfr  INT0IC     =       0x05D;   /* Interrupt 0 interrupt control register */
sfr  INT1IC     =       0x05E;   /* Interrupt 1 interrupt control register */
sfr  INT2IC     =       0x05F;   /* Interrupt 2 interrupt control register */


/*******************  DMA Registers  *****************************/

sfr  SAR00      =       0x020;   /* DMA0 source pointer (low) */
sfr  SAR01      =       0x021;   /* DMA0 source pointer (mid) */
sfr  SAR02      =       0x022;   /* DMA0 source pointer (high) */
sfr  DAR00      =       0x024;   /* DMA0 destination pointer (low) */
sfr  DAR01      =       0x025;   /* DMA0 destination pointer (mid) */
sfr  DAR02      =       0x026;   /* DMA0 destination pointer (high) */
sfr  TCR00      =       0x028;   /* DMA0 transfer counter (low) */
sfr  TCR01      =       0x029;   /* DMA0 transfer counter (high) */
sfrp TCR0       =       0x028;   /* DMA0 transfer counter */
sfr  DM0CON     =       0x02C;   /* DMA0 control register */
                                                
sfr  SAR10      =       0x020;   /* DMA1 source pointer (low) */
sfr  SAR11      =       0x021;   /* DMA1 source pointer (mid) */
sfr  SAR12      =       0x022;   /* DMA1 source pointer (high) */
sfr  DAR10      =       0x024;   /* DMA1 destination pointer (low) */
sfr  DAR11      =       0x025;   /* DMA1 destination pointer (mid) */
sfr  DAR12      =       0x026;   /* DMA1 destination pointer (high) */
sfr  TCR10      =       0x028;   /* DMA1 transfer counter (low) */
sfr  TCR11      =       0x029;   /* DMA1 transfer counter (high) */
sfrp TCR1       =       0x028;   /* DMA1 transfer counter */
sfr  DM1CON     =       0x02C;   /* DMA1 control register */

sfr  DM0SL      =       0x3B8;   /* DMA0 cause selection */
sfr  DM1SL      =       0x3BA;   /* DMA1 cause selection */


/*******************  Timer Registers  ***************************/

sfr  TABSR      =       0x380;   /* Timer A/B count start flags */
sfr  CPSRF      =       0x381;   /* Clock prescaler reset flag */
sfr  ONSF       =       0x382;   /* One-shot start flagl */
sfr  TRGSR      =       0x383;   /* Trigger select register */
sfr  UDF        =       0x384;   /* Up- down-count selection flag */

sfr  TA0L       =       0x386;   /* Timer A0 (low byte) */
sfr  TA0H       =       0x387;   /* Timer A0 (high byte) */
sfrp TA0        =       0x386;   /* Timer A0 */
sfr  TA1L       =       0x388;   /* Timer A1 (low byte) */
sfr  TA1H       =       0x389;   /* Timer A1 (high byte) */
sfrp TA1        =       0x388;   /* Timer A1 */
sfr  TA2L       =       0x38A;   /* Timer A2 (low byte) */
sfr  TA2H       =       0x38B;   /* Timer A2 (high byte) */
sfrp TA2        =       0x38A;   /* Timer A2 */
sfr  TA3L       =       0x38C;   /* Timer A3 (low byte) */
sfr  TA3H       =       0x38D;   /* Timer A3 (high byte) */
sfrp TA3        =       0x38C;   /* Timer A3 */
sfr  TA4L       =       0x38E;   /* Timer A4 (low byte) */
sfr  TA4H       =       0x38F;   /* Timer A4 (high byte) */
sfrp TA4        =       0x38E;   /* Timer A4 */
sfr  TB0L       =       0x390;   /* Timer B0 (low byte) */
sfr  TB0H       =       0x391;   /* Timer B0 (high byte) */
sfrp TB0        =       0x390;   /* Timer B0 */
sfr  TB1L       =       0x392;   /* Timer B1 (low byte) */
sfr  TB1H       =       0x393;   /* Timer B1 (high byte) */
sfrp TB1        =       0x392;   /* Timer B1 */
sfr  TB2L       =       0x394;   /* Timer B2 (low byte) */
sfr  TB2H       =       0x395;   /* Timer B2 (high byte) */
sfrp TB2        =       0x394;   /* Timer B2 */

sfr  TA0MR      =       0x396;   /* Timer A0 mode register */
sfr  TA1MR      =       0x397;   /* Timer A1 mode register */
sfr  TA2MR      =       0x398;   /* Timer A2 mode register */
sfr  TA3MR      =       0x399;   /* Timer A3 mode register */
sfr  TA4MR      =       0x39A;   /* Timer A4 mode register */
sfr  TB0MR      =       0x39B;   /* Timer B0 mode register */
sfr  TB1MR      =       0x39C;   /* Timer B1 mode register */
sfr  TB2MR      =       0x39D;   /* Timer B2 mode register */

sfr  TBSR       =       0x340;   /* Timer B3,4,5 count start flag*/
sfr  TB3L       =       0x350;   /* Timer B3 (low byte)    */
sfr  TB3H       =       0x351;   /* Timer B3 (high byte) */
sfrp TB3        =       0x350;   /* Timer B3 */
sfr  TB4L       =       0x352;   /* Timer B4 (low byte) */
sfr  TB4H       =       0x353;   /* Timer B4 (high byte) */
sfrp TB4        =       0x352;   /* Timer B4 */
sfr  TB5L       =       0x354;   /* Timer B5 (low byte) */
sfr  TB5H       =       0x355;   /* Timer B5 (high byte) */
sfrp TB5        =       0x354;   /* Timer B5 */

sfr  TB3MR      =       0x35B;   /* Timer B3 mode register */
sfr  TB4MR      =       0x35C;   /* Timer B4 mode register */
sfr  TB5MR      =       0x35D;   /* Timer B5 mode register */

sfr  TA11L      =       0x342;   /* Timer A1-1 register (low byte)*/
sfr  TA11H      =       0x343;   /* Timer A1-1 register (high byte)*/
sfrp TA11       =       0x342;   /* Timer A1-1 register */
sfr  TA21L      =       0x344;   /* Timer A2-1 register (low byte) */
sfr  TA21H      =       0x345;   /* Timer A2-1 register (high byte) */
sfrp TA21       =       0x344;   /* Timer A2-1 register */
sfr  TA41L      =       0x346;   /* Timer A4-1 register (low byte) */
sfr  TA41H      =       0x347;   /* Timer A4-1 register (high byte) */
sfrp TA41       =       0x346;   /* Timer A4-1 register */
sfr  INVC0      =       0x348;   /* Three-phase PWM control register 0 */
sfr  INVC1      =       0x349;   /* Three-phase PWM control register 1 */
sfr  IDB0       =       0x34A;   /* Three-phase output buffer register 0 */
sfr  IDB1       =       0x34B;   /* Three-phase output buffer register 1 */
sfr  DTT        =       0x34C;   /* Dead time timer */
sfr  ICTB2      =       0x34D;   /* Timer B2 interrupt occurence frequency set coutnter */

/*******************  UART Registers  ****************************/

sfr  U0MR       =       0x3A0;   /* UART 0 mode register */
sfr  U0BRG      =       0x3A1;   /* UART 0 baud rate generator */
sfr  U0TBL      =       0x3A2;   /* UART 0 transmit buffer (low byte) */
sfr  U0TBH      =       0x3A3;   /* UART 0 transmit buffer (high byte) */
sfrp U0TB       =       0x3A2;   /* UART 0 transmit buffer */
sfr  U0C0       =       0x3A4;   /* UART 0 control register 0 */
sfr  U0C1       =       0x3A5;   /* UART 0 control register 1 */
sfrp U0C        =       0x3A4;   /* UART 0 control register */
sfr  U0RBL      =       0x3A6;   /* UART 0 receive buffer (low byte) */
sfr  U0RBH      =       0x3A7;   /* UART 0 receive buffer (high byte) */
sfrp U0RB       =       0x3A6;   /* UART 0 receive buffer */

sfr  U1MR       =       0x3A8;   /* UART 1 mode register */
sfr  U1BRG      =       0x3A9;   /* UART 1 baud rate generator */
sfr  U1TBL      =       0x3AA;   /* UART 1 transmit buffer (low byte) */
sfr  U1TBH      =       0x3AB;   /* UART 1 transmit buffer (high byte) */
sfrp U1TB       =       0x3AA;   /* UART 1 transmit buffer */
sfr  U1C0       =       0x3AC;   /* UART 1 control register 0 */
sfr  U1C1       =       0x3AD;   /* UART 1 control register 1 */
sfrp U1C        =       0x3AC;   /* UART 1 control register */
sfr  U1RBL      =       0x3AE;   /* UART 1 receive buffer (low byte) */
sfr  U1RBH      =       0x3AF;   /* UART 1 receive buffer (high byte) */
sfrp U1RB       =       0x3AE;   /* UART 1 receive buffer */
sfr  UCON       =       0x3B0;   /* UART control register 2 */

sfr  ISFR       =       0x35F;   /* Interrupt cause select register*/
sfr  S3TRR      =       0x360;   /* SI/O3 transmit/receive register*/
sfr  S3C        =       0x362;   /* SI/O3 control register */
sfr  S3BRG     	=       0x363;   /* SI/O3 bit rate generator */
sfr  S4TRR      =       0x364;   /* SI/O4 transmit/reveive register */
sfr  S4C        =       0x366;   /* SI/O4 control register */
sfr  S4BRG		=       0x367;   /* SI/O4 bit rate generator */

sfr  U2SMR2     =       0x376;   /* UART 2 special mode register 2 */
sfr  U2SMR      =       0x377;   /* UART 2 special mode register */
sfr  U2MR       =       0x378;   /* UART 2 transmit/receive mode register */
sfr  U2BRG      =       0x379;   /* UART 2 bit rate generator */
sfr  U2TBL      =       0x37A;   /* UART 2 transmit buffer register (low byte) */
sfr  U2TBH      =       0x37B;   /* UART 2 transmit buffer register (high byte) */
sfrp U2TB       =       0x37A;   /* UART 2 transmit buffer register */
sfr  U2C0       =       0x37C;   /* UART 2 transmit/receive control register 0 */
sfr  U2C1       =       0x37D;   /* UART 2 transmit/receive control register 1 */
sfr  U2RBL      =       0x37E;   /* UART 2 receive buffer register (low byte) */
sfr  U2RBH      =       0x37F;   /* UART 2 receive buffer register (high byte) */
sfrp U2RB       =       0x37E;   /* UART 2 receive buffer register */
 

/*******************  CRC register  ******************************/

sfr  CRCDL      =       0x3BC;   /* CRC data register (low byte) */
sfr  CRCDH      =       0x3BD;   /* CRC data register (high byte) */
sfrp CRCD       =       0x3BC;   /* CRC data register */
sfr  CRCIN      =       0x3BE;   /* CRC input register */


/*******************  A/D Converter  *****************************/

sfr  AD0L       =       0x3C0;   /* A/D register 0 (low byte) */
sfr  AD0H       =       0x3C1;   /* A/D register 0 (high byte) */
sfrp AD0        =       0x3C0;   /* A/D register 0 */
sfr  AD1L       =       0x3C2;   /* A/D register 1 (low byte) */
sfr  AD1H       =       0x3C3;   /* A/D register 1 (high byte) */
sfrp AD1        =       0x3C2;   /* A/D register 1 */
sfr  AD2L       =       0x3C4;   /* A/D register 2 (low byte) */
sfr  AD2H       =       0x3C5;   /* A/D register 2 (high byte) */
sfrp AD2        =       0x3C4;   /* A/D register 2 */
sfr  AD3L       =       0x3C6;   /* A/D register 3 (low byte) */
sfr  AD3H       =       0x3C7;   /* A/D register 3 (high byte) */
sfrp AD3        =       0x3C6;   /* A/D register 3 */
sfr  AD4L       =       0x3C8;   /* A/D register 4 (low byte) */
sfr  AD4H       =       0x3C9;   /* A/D register 4 (high byte) */
sfrp AD4        =       0x3C8;   /* A/D register 4 */
sfr  AD5L       =       0x3CA;   /* A/D register 5 (low byte) */
sfr  AD5H       =       0x3CB;   /* A/D register 5 (high byte) */
sfrp AD5        =       0x3CA;   /* A/D register 5 */
sfr  AD6L       =       0x3CC;   /* A/D register 6 (low byte) */
sfr  AD6H       =       0x3CD;   /* A/D register 6 (high byte) */
sfrp AD6        =       0x3CC;   /* A/D register 6 */
sfr  AD7L       =       0x3CE;   /* A/D register 7 (low byte) */
sfr  AD7H       =       0x3CF;   /* A/D register 7 (high byte) */
sfrp AD7        =       0x3CE;   /* A/D register 7 */

sfr  ADCON2     =       0x3D4;   /* A/D control register 0 */
sfr  ADCON0     =       0x3D6;   /* A/D control register 0 */
sfr  ADCON1     =       0x3D7;   /* A/D control register 1 */
sfrp ADCON      =       0x3D6;   /* A/D control register */


/*******************  D-A Converter  *****************************/

sfr  DA0        =       0x3D8;   /* D-A register 0 */
sfr  DA1        =       0x3DA;   /* D-A register 1 */
sfr  DACON      =       0x3DC;   /* D-A control register */


/*******************  Port Registers  ***************************/

sfr  P0         =       0x3E0;   /* Port P0 register */
sfr  P1         =       0x3E1;   /* Port P1 register */
sfrp P01        =       0x3E0;   /* Port P0 and P1 register */
sfr  PD0        =       0x3E2;   /* Port P0 direction register */
sfr  PD1        =       0x3E3;   /* Port P1 direction register */
sfr  PD01       =       0x3E2;   /* Port P0 and P1 direction register */
sfr  P2         =       0x3E4;   /* Port P2 register */
sfr  P3         =       0x3E5;   /* Port P3 register */
sfrp P23        =       0x3E4;   /* Port P2 and P3 register */
sfr  PD2        =       0x3E6;   /* Port P2 direction register */
sfr  PD3        =       0x3E7;   /* Port P3 direction register */
sfr  PD23       =       0x3E6;   /* Port P2 and P3 direction register */
sfr  P4         =       0x3E8;   /* Port P4 register */
sfr  P5         =       0x3E9;   /* Port P5 register */
sfrp P45        =       0x3E8;   /* Port P4 and P5 register */
sfr  PD4        =       0x3EA;   /* Port P4 direction register */
sfr  PD5        =       0x3EB;   /* Port P5 direction register */
sfr  PD45       =       0x3EA;   /* Port P4 and P5 direction register */
sfr  P6         =       0x3EC;   /* Port P6 register */
sfr  P7         =       0x3ED;   /* Port P7 register */
sfrp P67        =       0x3EC;   /* Port P6 and P7 register */
sfr  PD6        =       0x3EE;   /* Port P6 direction register */
sfr  PD7        =       0x3EF;   /* Port P7 direction register */
sfr  PD67       =       0x3EE;   /* Port P6 and P7 direction register */
sfr  P8         =       0x3F0;   /* Port P8 register */
sfr  P9         =       0x3F1;   /* Port P9 register */
sfrp P89        =       0x3F0;   /* Port P8 and P9 register */
sfr  PD8        =       0x3F2;   /* Port P8 direction register */
sfr  PD9        =       0x3F3;   /* Port P9 direction register */
sfr  PD89       =       0x3F2;   /* Port P8 and P9 direction register */
sfr  P10        =       0x3F4;   /* Port P10 register */
sfr  PD10       =       0x3F6;   /* Port P10 direction register */

sfr  PUR0       =       0x3FC;   /* Pull-up register 0 */
sfr  PUR1       =       0x3FD;   /* Pull-up register 1 */
sfrp PUR01      =       0x3FC;   /* Pull-up register 0 and 1 */
sfr  PUR2       =       0x3FE;   /* Pull-up register 2 */
sfr  PCR        =       0x3FF;   /* Port control register*/

#else                        // if no specified compiler is used

#define PM0    (*(unsigned char* ) 0x004)   // Processor Mode Register 0
#define PM1    (*(unsigned char* ) 0x005)   // Processor Mode Register 1
#define CM0    (*(unsigned char* ) 0x006)   // System clock control register 0 
#define CM1    (*(unsigned char* ) 0x007)   // System clock control register 1 
#define CM     (*(unsigned int * ) 0x006)   // System clock control register   
#define CSR    (*(unsigned char* ) 0x008)   // Chip select control register    

/************************  Watchdog Timer  ********************************/

#define WDTS   (*(unsigned char* ) 0x00E)   // Watchdog timer start register   
#define WDC    (*(unsigned char* ) 0x00F)   // Watchdog timer control register 

/************************  Interrupt Control Register  ********************/

#define AIER   (*(unsigned char* ) 0x009)   // Address match interrupt enable           
#define PRCR   (*(unsigned char* ) 0x00A)   // Protect register                         
#define RMAD00 (*(unsigned char* ) 0x010)   // Address match interrupt register 0 (low) 
#define RMAD01 (*(unsigned char* ) 0x011)   // Address match interrupt register 0 (mid) 
#define RMAD02 (*(unsigned char* ) 0x012)   // Address match interrupt register 0 (high)
#define RMAD10 (*(unsigned char* ) 0x014)   // Address match interrupt register 1 (low) 
#define RMAD11 (*(unsigned char* ) 0x015)   // Address match interrupt register 1 (mid) 
#define RMAD12 (*(unsigned char* ) 0x016)   // Address match interrupt register 1 (high)
#define DMA0IC (*(unsigned char* ) 0x04B)   // DMA0 interrupt control register          
#define DMA1IC (*(unsigned char* ) 0x04C)   // DMA1 interrupt control register          
#define KUPIC  (*(unsigned char* ) 0x04D)   // Key input interrupt control register
#define ADIC   (*(unsigned char* ) 0x04E)   // A-D converter interrupt control register
#define S0TIC  (*(unsigned char* ) 0x051)   // UART0 transmit interrupt control register
#define S0RIC  (*(unsigned char* ) 0x052)   // UART0 receive interrupt control register 
#define S1TIC  (*(unsigned char* ) 0x053)   // UART1 transmit interrupt control register
#define S1RIC  (*(unsigned char* ) 0x054)   // UART1 receive interrupt control register 
#define TA0IC  (*(unsigned char* ) 0x055)   // Timer A0 interrupt control register      
#define TA1IC  (*(unsigned char* ) 0x056)   // Timer A1 interrupt control register      
#define TA2IC  (*(unsigned char* ) 0x057)   // Timer A2 interrupt control register      
#define TA3IC  (*(unsigned char* ) 0x058)   // Timer A3 interrupt control register      
#define TA4IC  (*(unsigned char* ) 0x059)   // Timer A4 interrupt control register      
#define TB0IC  (*(unsigned char* ) 0x05A)   // Timer B0 interrupt control register      
#define TB1IC  (*(unsigned char* ) 0x05B)   // Timer B1 interrupt control register      
#define TB2IC  (*(unsigned char* ) 0x05C)   // Timer B2 interrupt control register      
#define INT0IC (*(unsigned char* ) 0x05D)   // Interrupt 0 interrupt control register   
#define INT1IC (*(unsigned char* ) 0x05E)   // Interrupt 1 interrupt control register   
#define INT2IC (*(unsigned char* ) 0x05F)   // Interrupt 2 interrupt control register   

/************************  DMA Registers  *********************************/

#define SAR00  (*(unsigned char* ) 0x020)   // DMA0 source pointer (low)        
#define SAR01  (*(unsigned char* ) 0x021)   // DMA0 source pointer (mid)        
#define SAR02  (*(unsigned char* ) 0x022)   // DMA0 source pointer (high)       
#define DAR00  (*(unsigned char* ) 0x024)   // DMA0 destination pointer (low)   
#define DAR01  (*(unsigned char* ) 0x025)   // DMA0 destination pointer (mid)   
#define DAR02  (*(unsigned char* ) 0x026)   // DMA0 destination pointer (high)  
#define TCR00  (*(unsigned char* ) 0x028)   // DMA0 transfer counter (low)      
#define TCR01  (*(unsigned char* ) 0x029)   // DMA0 transfer counter (high)     
#define TCR0   (*(unsigned int * ) 0x028)   // DMA0 transfer counter            
#define DM0CON (*(unsigned char* ) 0x02C)   // DMA0 control register            
                                  
#define SAR10  (*(unsigned char* ) 0x030)   // DMA1 source pointer (low)        
#define SAR11  (*(unsigned char* ) 0x031)   // DMA1 source pointer (mid)        
#define SAR12  (*(unsigned char* ) 0x032)   // DMA1 source pointer (high)       
#define DAR10  (*(unsigned char* ) 0x034)   // DMA1 destination pointer (low)   
#define DAR11  (*(unsigned char* ) 0x035)   // DMA1 destination pointer (mid)   
#define DAR12  (*(unsigned char* ) 0x036)   // DMA1 destination pointer (high)  
#define TCR10  (*(unsigned char* ) 0x038)   // DMA1 transfer counter (low)      
#define TCR11  (*(unsigned char* ) 0x039)   // DMA1 transfer counter (high)     
#define TCR1   (*(unsigned int * ) 0x038)   // DMA1 transfer counter            
#define DM1CON (*(unsigned char* ) 0x03C)   // DMA1 control register            
                                  
#define DM0SL  (*(unsigned char* )  0x3B8)   // DMA0 cause selection  
#define DM1SL  (*(unsigned char* )  0x3BA)   // DMA1 cause selection  

/************************  Timer Registers  *******************************/

#define TABSR  (*(unsigned char* ) 0x380)   // Timer A/B count start flags   
#define CPSRF  (*(unsigned char* ) 0x381)   // Clock prescaler reset flag    
#define ONSF   (*(unsigned char* ) 0x382)   // One-shot start flagl          
#define TRGSR  (*(unsigned char* ) 0x383)   // Trigger select register       
#define UDF    (*(unsigned char* ) 0x384)   // Up- down-count selection flag 
                                  
#define TA0L   (*(unsigned char* ) 0x386)   // Timer A0 (low byte)  
#define TA0H   (*(unsigned char* ) 0x387)   // Timer A0 (high byte) 
#define TA0    (*(unsigned int * ) 0x386)   // Timer A0             
#define TA1L   (*(unsigned char* ) 0x388)   // Timer A1 (low byte)  
#define TA1H   (*(unsigned char* ) 0x389)   // Timer A1 (high byte) 
#define TA1    (*(unsigned int * ) 0x388)   // Timer A1             
#define TA2L   (*(unsigned char* ) 0x38A)   // Timer A2 (low byte)  
#define TA2H   (*(unsigned char* ) 0x38B)   // Timer A2 (high byte) 
#define TA2    (*(unsigned int * ) 0x38A)   // Timer A2             
#define TA3L   (*(unsigned char* ) 0x38C)   // Timer A3 (low byte)  
#define TA3H   (*(unsigned char* ) 0x38D)   // Timer A3 (high byte) 
#define TA3    (*(unsigned int * ) 0x38C)   // Timer A3             
#define TA4L   (*(unsigned char* ) 0x38E)   // Timer A4 (low byte)  
#define TA4H   (*(unsigned char* ) 0x38F)   // Timer A4 (high byte) 
#define TA4    (*(unsigned int * ) 0x38E)   // Timer A4             
#define TB0L   (*(unsigned char* ) 0x390)   // Timer B0 (low byte)  
#define TB0H   (*(unsigned char* ) 0x391)   // Timer B0 (high byte) 
#define TB0    (*(unsigned int * ) 0x390)   // Timer B0             
#define TB1L   (*(unsigned char* ) 0x392)   // Timer B1 (low byte)  
#define TB1H   (*(unsigned char* ) 0x393)   // Timer B1 (high byte) 
#define TB1    (*(unsigned int * ) 0x392)   // Timer B1             
#define TB2L   (*(unsigned char* ) 0x394)   // Timer B2 (low byte)  
#define TB2H   (*(unsigned char* ) 0x395)   // Timer B2 (high byte) 
#define TB2    (*(unsigned int * ) 0x394)   // Timer B2             
                                  
#define TA0MR  (*(unsigned char* ) 0x396)   // Timer A0 mode register  
#define TA1MR  (*(unsigned char* ) 0x397)   // Timer A1 mode register  
#define TA2MR  (*(unsigned char* ) 0x398)   // Timer A2 mode register  
#define TA3MR  (*(unsigned char* ) 0x399)   // Timer A3 mode register  
#define TA4MR  (*(unsigned char* ) 0x39A)   // Timer A4 mode register  
#define TB0MR  (*(unsigned char* ) 0x39B)   // Timer B0 mode register  
#define TB1MR  (*(unsigned char* ) 0x39C)   // Timer B1 mode register  
#define TB2MR  (*(unsigned char* ) 0x39D)   // Timer B2 mode register  

/************************  UART Registers  ********************************/

#define U0MR   (*(unsigned char* ) 0x3A0)   // UART 0 mode register                
#define U0BRG  (*(unsigned char* ) 0x3A1)   // UART 0 baud rate generator          
#define U0TBL  (*(unsigned char* ) 0x3A2)   // UART 0 transmit buffer (low byte)   
#define U0TBH  (*(unsigned char* ) 0x3A3)   // UART 0 transmit buffer (high byte)  
#define U0TB   (*(unsigned int * ) 0x3A2)   // UART 0 transmit buffer              
#define U0C0   (*(unsigned char* ) 0x3A4)   // UART 0 control register 0           
#define U0C1   (*(unsigned char* ) 0x3A5)   // UART 0 control register 1           
#define U0C    (*(unsigned int * ) 0x3A4)   // UART 0 control register             
#define U0RBL  (*(unsigned char* ) 0x3A6)   // UART 0 receive buffer (low byte)    
#define U0RBH  (*(unsigned char* ) 0x3A7)   // UART 0 receive buffer (high byte)   
#define U0RB   (*(unsigned int * ) 0x3A6)   // UART 0 receive buffer               
                                  
#define U1MR   (*(unsigned char* ) 0x3A8)   // UART 1 mode register                
#define U1BRG  (*(unsigned char* ) 0x3A9)   // UART 1 baud rate generator          
#define U1TBL  (*(unsigned char* ) 0x3AA)   // UART 1 transmit buffer (low byte)   
#define U1TBH  (*(unsigned char* ) 0x3AB)   // UART 1 transmit buffer (high byte)  
#define U1TB   (*(unsigned int * ) 0x3AA)   // UART 1 transmit buffer              
#define U1C0   (*(unsigned char* ) 0x3AC)   // UART 1 control register 0           
#define U1C1   (*(unsigned char* ) 0x3AD)   // UART 1 control register 1           
#define U1C    (*(unsigned int * ) 0x3AC)   // UART 1 control register             
#define U1RBL  (*(unsigned char* ) 0x3AE)   // UART 1 receive buffer (low byte)    
#define U1RBH  (*(unsigned char* ) 0x3AF)   // UART 1 receive buffer (high byte)   
#define U1RB   (*(unsigned int * ) 0x3AE)   // UART 1 receive buffer               
#define UCON   (*(unsigned char* ) 0x3B0)   // UART control register 2             

/************************  CRC register  **********************************/

#define CRCDL  (*(unsigned char* ) 0x3BC)   // CRC data register (low byte)  
#define CRCDH  (*(unsigned char* ) 0x3BD)   // CRC data register (high byte) 
#define CRCD   (*(unsigned int * ) 0x3BC)   // CRC data register             
#define CRCIN  (*(unsigned char* ) 0x3BE)   // CRC input register            

/************************  A/D Converter  *********************************/

#define AD0L   (*(unsigned char* ) 0x3C0)   // A/D register 0 (low byte)   
#define AD0H   (*(unsigned char* ) 0x3C1)   // A/D register 0 (high byte)  
#define AD0    (*(unsigned int * ) 0x3C0)   // A/D register 0              
#define AD1L   (*(unsigned char* ) 0x3C2)   // A/D register 1 (low byte)   
#define AD1H   (*(unsigned char* ) 0x3C3)   // A/D register 1 (high byte)  
#define AD1    (*(unsigned int * ) 0x3C2)   // A/D register 1              
#define AD2L   (*(unsigned char* ) 0x3C4)   // A/D register 2 (low byte)   
#define AD2H   (*(unsigned char* ) 0x3C5)   // A/D register 2 (high byte)  
#define AD2    (*(unsigned int * ) 0x3C4)   // A/D register 2              
#define AD3L   (*(unsigned char* ) 0x3C6)   // A/D register 3 (low byte)   
#define AD3H   (*(unsigned char* ) 0x3C7)   // A/D register 3 (high byte)  
#define AD3    (*(unsigned int * ) 0x3C6)   // A/D register 3              
#define AD4L   (*(unsigned char* ) 0x3C8)   // A/D register 4 (low byte)   
#define AD4H   (*(unsigned char* ) 0x3C9)   // A/D register 4 (high byte)  
#define AD4    (*(unsigned int * ) 0x3C8)   // A/D register 4              
#define AD5L   (*(unsigned char* ) 0x3CA)   // A/D register 5 (low byte)   
#define AD5H   (*(unsigned char* ) 0x3CB)   // A/D register 5 (high byte)  
#define AD5    (*(unsigned int * ) 0x3CA)   // A/D register 5              
#define AD6L   (*(unsigned char* ) 0x3CC)   // A/D register 6 (low byte)   
#define AD6H   (*(unsigned char* ) 0x3CD)   // A/D register 6 (high byte)  
#define AD6    (*(unsigned int * ) 0x3CC)   // A/D register 6              
#define AD7L   (*(unsigned char* ) 0x3CE)   // A/D register 7 (low byte)   
#define AD7H   (*(unsigned char* ) 0x3CF)   // A/D register 7 (high byte)  
#define AD7    (*(unsigned int * ) 0x3CE)   // A/D register 7              
                                  
#define ADCON2 (*(unsigned char* ) 0x3D4)   // A/D control register 2
#define ADCON0 (*(unsigned char* ) 0x3D6)   // A/D control register 0  
#define ADCON1 (*(unsigned char* ) 0x3D7)   // A/D control register 1  
#define ADCON  (*(unsigned int * ) 0x3D6)   // A/D control register    

/************************  D-A Converter  *********************************/

#define DA0    (*(unsigned char* ) 0x3D8)   // D-A register 0        
#define DA1    (*(unsigned char* ) 0x3DA)   // D-A register 1        
#define DACON  (*(unsigned char* ) 0x3DC)   // D-A control register  

/************************  Port Registers  ********************************/

#define P0     (*(unsigned char* ) 0x3E0)   // Port P0 register                   
#define P1     (*(unsigned char* ) 0x3E1)   // Port P1 register                   
#define P01    (*(unsigned int * ) 0x3E0)   // Port P0 and P1 register            
#define PD0    (*(unsigned char* ) 0x3E2)   // Port P0 direction register         
#define PD1    (*(unsigned char* ) 0x3E3)   // Port P1 direction register         
#define PD01   (*(unsigned int * ) 0x3E2)   // Port P0 and P1 direction register  
#define P2     (*(unsigned char* ) 0x3E4)   // Port P2 register                   
#define P3     (*(unsigned char* ) 0x3E5)   // Port P3 register                   
#define P23    (*(unsigned int * ) 0x3E4)   // Port P2 and P3 register            
#define PD2    (*(unsigned char* ) 0x3E6)   // Port P2 direction register         
#define PD3    (*(unsigned char* ) 0x3E7)   // Port P3 direction register         
#define PD23   (*(unsigned int * ) 0x3E6)   // Port P2 and P3 direction register  
#define P4     (*(unsigned char* ) 0x3E8)   // Port P4 register                   
#define P5     (*(unsigned char* ) 0x3E9)   // Port P5 register                   
#define P45    (*(unsigned int * ) 0x3E8)   // Port P4 and P5 register            
#define PD4    (*(unsigned char* ) 0x3EA)   // Port P4 direction register         
#define PD5    (*(unsigned char* ) 0x3EB)   // Port P5 direction register         
#define PD45   (*(unsigned int * ) 0x3EA)   // Port P4 and P5 direction register  
#define P6     (*(unsigned char* ) 0x3EC)   // Port P6 register                   
#define P7     (*(unsigned char* ) 0x3ED)   // Port P7 register                   
#define P67    (*(unsigned int * ) 0x3EC)   // Port P6 and P7 register            
#define PD6    (*(unsigned char* ) 0x3EE)   // Port P6 direction register         
#define PD7    (*(unsigned char* ) 0x3EF)   // Port P7 direction register         
#define PD67   (*(unsigned int * ) 0x3EE)   // Port P6 and P7 direction register  
#define P8     (*(unsigned char* ) 0x3F0)   // Port P8 register                   
#define P9     (*(unsigned char* ) 0x3F1)   // Port P9 register                   
#define P89    (*(unsigned int * ) 0x3F0)   // Port P8 and P9 register            
#define PD8    (*(unsigned char* ) 0x3F2)   // Port P8 direction register         
#define PD9    (*(unsigned char* ) 0x3F3)   // Port P9 direction register         
#define PD89   (*(unsigned int * ) 0x3F2)   // Port P8 and P9 direction register  
#define P10    (*(unsigned char* ) 0x3F4)   // Port P10 register                  
#define PD10   (*(unsigned char* ) 0x3F6)   // Port P10 direction register        
               
#define PUR0   (*(unsigned char* ) 0x3FC)   // Pull-up register 0                 
#define PUR1   (*(unsigned char* ) 0x3FD)   // Pull-up register 1                 
#define PUR2   (*(unsigned char* ) 0x3FE)   // Pull-up register 2                 

//#endif                        // #endif for general compiler

#endif                        // #endif for #ifdef __IAR_SYSTEMS_ICC

#endif                        // #endif for #ifdef NC30
