/*
**===========================================================================
**	TEXT1375.C
**---------------------------------------------------------------------------
**
**  Created 1998, Epson Research & Development (Vancouver Design Centre)
**
**  Copyright (c) 1998 Epson Research and Development, Inc.
**  All Rights Reserved.
**
**---------------------------------------------------------------------------
**
**  $Header: /1375/HAL/HAL_TEXT.C 5     4/13/00 3:44p Bobe $
**
**  $Revision: 5 $
**
**  $Log: /1375/HAL/HAL_TEXT.C $
// 6     11/23/01 KTG
// - Addapted for M16C use in GTK6 Board 
// _ Header file name changed to sed1375.h
//
// 5     4/13/00 3:44p Bobe
// - Fixed the seDrawText() routine
// 
// 4     3/17/99 11:02a Bobe
// Release 1.00 check-in
// 
// 3     2/05/99 3:13p Bobe
// - Corrected a couple of calculation problems in HAL_VIRT.C
// 
// 2     1/15/99 10:12a Bobe
// Release 1 - Beta 2 check-in
// - Fixed 1-bpp mono LUT error.
//   I was setting both LUT 0 and LUT 1 to black.
// - Fixed portrait mode calculation errors.
//   I incorrectly calculated the stride when the Line Byte Count register
// was 0.
// 
// 1     1/05/99 4:29p Bobe
// Initial check-in
**
**===========================================================================
*/

#include "sed1375.h"

#pragma ADDRESS SED137x_RAM 040000H
unsigned char far SED137x_RAM[];

/*
** Each character is 8 x 8 pixels.
*/
#define MAX_FONT    97

BYTE FontTable[MAX_FONT][8] =
   { { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },   // (blank)
     { 0x30, 0x78, 0x78, 0x30, 0x30, 0x00, 0x30, 0x00 },   // !
     { 0x6C, 0x6C, 0x6C, 0x00, 0x00, 0x00, 0x00, 0x00 },   // "
     { 0x6C, 0x6C, 0xFE, 0x6C, 0xFE, 0x6C, 0x6C, 0x00 },   // #
     { 0x30, 0x7C, 0xC0, 0x78, 0x0C, 0xF8, 0x30, 0x00 },   // $
     { 0x00, 0xC6, 0xCC, 0x18, 0x30, 0x66, 0xC6, 0x00 },   // %
     { 0x38, 0x6C, 0x38, 0x76, 0xDC, 0xCC, 0x76, 0x00 },   // &
     { 0x60, 0x60, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00 },   // '
     { 0x18, 0x30, 0x60, 0x60, 0x60, 0x30, 0x18, 0x00 },   // (
     { 0x60, 0x30, 0x18, 0x18, 0x18, 0x30, 0x60, 0x00 },   // )
     { 0x00, 0x66, 0x3C, 0xFF, 0x3C, 0x66, 0x00, 0x00 },   // *
     { 0x00, 0x30, 0x30, 0xFC, 0x30, 0x30, 0x00, 0x00 },   // +
     { 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x30, 0x60 },   // ,
     { 0x00, 0x00, 0x00, 0xFC, 0x00, 0x00, 0x00, 0x00 },   // -
     { 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x30, 0x00 },   // .
     { 0x06, 0x0C, 0x18, 0x30, 0x60, 0xC0, 0x80, 0x00 },   // /
     { 0x7C, 0xC6, 0xCE, 0xDE, 0xF6, 0xE6, 0x7C, 0x00 },   // 0
     { 0x30, 0x70, 0x30, 0x30, 0x30, 0x30, 0xFC, 0x00 },   // 1
     { 0x78, 0xCC, 0x0C, 0x38, 0x60, 0xCC, 0xFC, 0x00 },   // 2
     { 0x78, 0xCC, 0x0C, 0x38, 0x0C, 0xCC, 0x78, 0x00 },   // 3
     { 0x1C, 0x3C, 0x6C, 0xCC, 0xFE, 0x0C, 0x1E, 0x00 },   // 4
     { 0xFC, 0xC0, 0xF8, 0x0C, 0x0C, 0xCC, 0x78, 0x00 },   // 5
     { 0x38, 0x60, 0xC0, 0xF8, 0xCC, 0xCC, 0x78, 0x00 },   // 6
     { 0xFC, 0xCC, 0x0C, 0x18, 0x30, 0x30, 0x30, 0x00 },   // 7
     { 0x78, 0xCC, 0xCC, 0x78, 0xCC, 0xCC, 0x78, 0x00 },   // 8
     { 0x78, 0xCC, 0xCC, 0x7C, 0x0C, 0x18, 0x70, 0x00 },   // 9
     { 0x00, 0x30, 0x30, 0x00, 0x00, 0x30, 0x30, 0x00 },   // :
     { 0x00, 0x30, 0x30, 0x00, 0x00, 0x30, 0x30, 0x60 },   // ;
     { 0x18, 0x30, 0x60, 0xC0, 0x60, 0x30, 0x18, 0x00 },   // <
     { 0x00, 0x00, 0xFC, 0x00, 0x00, 0xFC, 0x00, 0x00 },   // =
     { 0x60, 0x30, 0x18, 0x0C, 0x18, 0x30, 0x60, 0x00 },   // >
     { 0x78, 0xCC, 0x0C, 0x18, 0x30, 0x00, 0x30, 0x00 },   // ?
     { 0x7C, 0xC6, 0xDE, 0xDE, 0xDE, 0xC0, 0x78, 0x00 },   // @
     { 0x30, 0x78, 0xCC, 0xCC, 0xFC, 0xCC, 0xCC, 0x00 },   // A
     { 0xFC, 0x66, 0x66, 0x7C, 0x66, 0x66, 0xFC, 0x00 },   // B
     { 0x3C, 0x66, 0xC0, 0xC0, 0xC0, 0x66, 0x3C, 0x00 },   // C
     { 0xF8, 0x6C, 0x66, 0x66, 0x66, 0x6C, 0xF8, 0x00 },   // D
     { 0xFE, 0x62, 0x68, 0x78, 0x68, 0x62, 0xFE, 0x00 },   // E
     { 0xFE, 0x62, 0x68, 0x78, 0x68, 0x60, 0xF0, 0x00 },   // F
     { 0x3C, 0x66, 0xC0, 0xC0, 0xCE, 0x66, 0x3E, 0x00 },   // G
     { 0xCC, 0xCC, 0xCC, 0xFC, 0xCC, 0xCC, 0xCC, 0x00 },   // H
     { 0x78, 0x30, 0x30, 0x30, 0x30, 0x30, 0x78, 0x00 },   // I
     { 0x1E, 0x0C, 0x0C, 0x0C, 0xCC, 0xCC, 0x78, 0x00 },   // J
     { 0xE6, 0x66, 0x6C, 0x78, 0x6C, 0x66, 0xE6, 0x00 },   // K
     { 0xF0, 0x60, 0x60, 0x60, 0x62, 0x66, 0xFE, 0x00 },   // L
     { 0xC6, 0xEE, 0xFE, 0xFE, 0xD6, 0xC6, 0xC6, 0x00 },   // M
     { 0xC6, 0xE6, 0xF6, 0xDE, 0xCE, 0xC6, 0xC6, 0x00 },   // N
     { 0x38, 0x6C, 0xC6, 0xC6, 0xC6, 0x6C, 0x38, 0x00 },   // O
     { 0xFC, 0x66, 0x66, 0x7C, 0x60, 0x60, 0xF0, 0x00 },   // P
     { 0x78, 0xCC, 0xCC, 0xCC, 0xDC, 0x78, 0x1C, 0x00 },   // Q
     { 0xFC, 0x66, 0x66, 0x7C, 0x6C, 0x66, 0xE6, 0x00 },   // R
     { 0x78, 0xCC, 0xE0, 0x70, 0x1C, 0xCC, 0x78, 0x00 },   // S
     { 0xFC, 0xB4, 0x30, 0x30, 0x30, 0x30, 0x78, 0x00 },   // T
     { 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xFC, 0x00 },   // U
     { 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0x78, 0x30, 0x00 },   // V
     { 0xC6, 0xC6, 0xC6, 0xD6, 0xFE, 0xEE, 0xC6, 0x00 },   // W
     { 0xC6, 0xC6, 0x6C, 0x38, 0x38, 0x6C, 0xC6, 0x00 },   // X
     { 0xCC, 0xCC, 0xCC, 0x78, 0x30, 0x30, 0x78, 0x00 },   // Y
     { 0xFE, 0xC6, 0x8C, 0x18, 0x32, 0x66, 0xFE, 0x00 },   // Z
     { 0x78, 0x60, 0x60, 0x60, 0x60, 0x60, 0x78, 0x00 },   // [
     { 0xC0, 0x60, 0x30, 0x18, 0x0C, 0x06, 0x02, 0x00 },   // (backslash)
     { 0x78, 0x18, 0x18, 0x18, 0x18, 0x18, 0x78, 0x00 },   // ]
     { 0x10, 0x38, 0x6C, 0xC6, 0x00, 0x00, 0x00, 0x00 },   // ^
     { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF },   // _
     { 0x30, 0x30, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00 },   // `
     { 0x00, 0x00, 0x78, 0x0C, 0x7C, 0xCC, 0x76, 0x00 },   // a
     { 0xE0, 0x60, 0x60, 0x7C, 0x66, 0x66, 0xDC, 0x00 },   // b
     { 0x00, 0x00, 0x78, 0xCC, 0xC0, 0xCC, 0x78, 0x00 },   // c
     { 0x1C, 0x0C, 0x0C, 0x7C, 0xCC, 0xCC, 0x76, 0x00 },   // d
     { 0x00, 0x00, 0x78, 0xCC, 0xFC, 0xC0, 0x78, 0x00 },   // e
     { 0x38, 0x6C, 0x60, 0xF0, 0x60, 0x60, 0xF0, 0x00 },   // f
     { 0x00, 0x00, 0x76, 0xCC, 0xCC, 0x7C, 0x0C, 0xF8 },   // g
     { 0xE0, 0x60, 0x6C, 0x76, 0x66, 0x66, 0xE6, 0x00 },   // h
     { 0x30, 0x00, 0x70, 0x30, 0x30, 0x30, 0x78, 0x00 },   // i
     { 0x0C, 0x00, 0x0C, 0x0C, 0x0C, 0xCC, 0xCC, 0x78 },   // j
     { 0xE0, 0x60, 0x66, 0x6C, 0x78, 0x6C, 0xE6, 0x00 },   // k
     { 0x70, 0x30, 0x30, 0x30, 0x30, 0x30, 0x78, 0x00 },   // l
     { 0x00, 0x00, 0xCC, 0xFE, 0xFE, 0xD6, 0xC6, 0x00 },   // m
     { 0x00, 0x00, 0xF8, 0xCC, 0xCC, 0xCC, 0xCC, 0x00 },   // n
     { 0x00, 0x00, 0x78, 0xCC, 0xCC, 0xCC, 0x78, 0x00 },   // o
     { 0x00, 0x00, 0xDC, 0x66, 0x66, 0x7C, 0x60, 0xF0 },   // p
     { 0x00, 0x00, 0x76, 0xCC, 0xCC, 0x7C, 0x0C, 0x1E },   // q
     { 0x00, 0x00, 0xDC, 0x76, 0x66, 0x60, 0xF0, 0x00 },   // r
     { 0x00, 0x00, 0x7C, 0xC0, 0x78, 0x0C, 0xF8, 0x00 },   // s
     { 0x10, 0x30, 0x7C, 0x30, 0x30, 0x34, 0x18, 0x00 },   // t
     { 0x00, 0x00, 0xCC, 0xCC, 0xCC, 0xCC, 0x76, 0x00 },   // u
     { 0x00, 0x00, 0xCC, 0xCC, 0xCC, 0x78, 0x30, 0x00 },   // v
     { 0x00, 0x00, 0xC6, 0xD6, 0xFE, 0xFE, 0x6C, 0x00 },   // w
     { 0x00, 0x00, 0xC6, 0x6C, 0x38, 0x6C, 0xC6, 0x00 },   // x
     { 0x00, 0x00, 0xCC, 0xCC, 0xCC, 0x7C, 0x0C, 0xF8 },   // y
     { 0x00, 0x00, 0xFC, 0x98, 0x30, 0x64, 0xFC, 0x00 },   // z
     { 0x1C, 0x30, 0x30, 0xE0, 0x30, 0x30, 0x1C, 0x00 },   // {
     { 0x18, 0x18, 0x18, 0x00, 0x18, 0x18, 0x18, 0x00 },   // |
     { 0xE0, 0x30, 0x30, 0x1C, 0x30, 0x30, 0xE0, 0x00 },   // }
     { 0x76, 0xDC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },   // ~
     { 0x00, 0x10, 0x38, 0x6C, 0xC6, 0xC6, 0xFE, 0x00 },   // 127
     { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF } };   // block char

/*-------------------------------------------------------------------------*/

/*
**	seDrawText()
**
**	This routine draws text at the specified x,y co-ordinates in the
**	specified colors. If any character in the string to print is not
**	found in the font table then a "." is substituted.
**
**	Arguments:
**		Row	 - The TEXT row to draw the text at.
**		Col	 - The TEXT column to draw the text at.
**		pStr    - A pointer to the null terminated text to draw.
**		fg	 - ForeGround colour (LUT index).
**		bg	 - BackGround colour (LUT inded).
*/
void seDrawText( int Row, int Col, unsigned char far *pStr, int fg, int bg )
{
       HPBYTE gpMem;
	HPBYTE	lpVidMem, lpVidPtr, lpNewLine;
	BYTE	ch;
	UINT	uVidDat, VidTableVal;
	int		y, Bit, Byte;
	int		nBPP;
	int		nStride;

	gpMem = SED137x_RAM;

	seGetBitsPerPixel(&nBPP);
	seGetBytesPerScanline(&nStride);
	
	lpVidMem = gpMem + (UINT)((Row * nStride) * 8 + Col * nBPP);
	lpVidPtr = lpVidMem;
	lpNewLine = gpMem + (UINT)(((Row * 8) + 1) * nStride);

	switch (nBPP)
	{
		case 1:
			if (0 == (bg & 1))
				bg = 0x00;
			else
				bg = 0xFF;
			fg &= 0x01;														  

			while (*pStr != 0)
			{
				/*
				** Get the character. Substitute a "." if it's not in our
				** font table.
				*/
				ch = *pStr++;
				if ((ch < ' ') || (ch - ' ' > MAX_FONT -1))
					ch = '.';

				/*
				** For each pixel in the character width
				*/
				for (y = 0; y < 8; ++y)
				{
					uVidDat = bg;
					VidTableVal = FontTable[ch - ' '][y];

					for (Bit = 7; Bit >= 0; Bit--)
						if (VidTableVal & (1 << Bit))
							uVidDat |= (fg << Bit);

					*lpVidPtr = (BYTE)uVidDat;
					lpVidPtr += nStride;
				}

				/*
				** Finished the character. Point our base to the next
				** video location. If we reach the end of the display
				** then point down one more row.
				*/
				lpVidMem++;
				if (lpVidMem == lpNewLine)
				{
					Row++;
					lpVidMem = gpMem + (UINT)((Row * nStride) * 8);
					lpNewLine = gpMem + (UINT)(((Row * 8) + 1) * nStride);
				}
				lpVidPtr = lpVidMem;
			}
			break;

		case 2:
			bg &= 0x03;
			bg = bg << 6 | bg << 4 |  bg << 2 | bg;
			fg &= 0x03;
	
			while (*pStr != 0)
			{
				ch = *pStr++;
				if ((ch < ' ') || (ch - ' ' > MAX_FONT - 1))
					ch = '.';
	
				for (y = 0; y < 8; ++y)
				{
					uVidDat = bg;
					VidTableVal = FontTable[ch - ' '][y];

					for (Bit = 7; Bit >= 4; Bit--)
						if (VidTableVal & (1 << Bit))
							uVidDat |= (fg << ((Bit & 3) << 1));
	
					*lpVidPtr = (BYTE)uVidDat;
					lpVidPtr++;
					
					uVidDat = bg;
					for (Bit = 3; Bit >= 0; Bit--)
						if (VidTableVal & (1 << Bit))
							uVidDat |= (fg << (Bit << 1));

					*lpVidPtr++ = (BYTE)uVidDat;
					lpVidPtr += nStride - 2;
				}
	
				lpVidMem += 2;
				if (lpVidMem >= lpNewLine)
				{
					Row++;
					lpVidMem = gpMem + (UINT)((Row * nStride) * 8);
					lpNewLine = gpMem + (UINT)(((Row * 8) + 1) * nStride);
				}
				lpVidPtr = lpVidMem;
			}
			break;
	
		case 4:
		       bg &= 0x0F;
			bg = bg | bg << 4;
			fg &= 0x0F;
	
			while (*pStr != 0)
			{
				ch = *pStr++;
				if ((ch < ' ') || (ch - ' ' > MAX_FONT-1))
					ch = '.';
	
				for (y = 0; y < 8; ++y)
				{
					VidTableVal = FontTable[ch - ' '][y];
					uVidDat = bg;
	
					if (VidTableVal & 0x80)
						uVidDat |= (fg << 4);
	
					if (VidTableVal & 0x40)
						uVidDat |= fg;

					*lpVidPtr++ = (BYTE)uVidDat;
					uVidDat = bg;

					if (VidTableVal & 0x20)
						uVidDat |= (fg << 4);

					if (VidTableVal & 0x10)
						uVidDat |= fg;

					*lpVidPtr++ = (BYTE) uVidDat;
					uVidDat = bg;

					if (VidTableVal & 0x08)
						uVidDat |= (fg << 4);

					if (VidTableVal & 0x04)
						uVidDat |= fg;

					*lpVidPtr++ = (BYTE)uVidDat;
					uVidDat = bg;

					if (VidTableVal & 0x02)
						uVidDat |= (fg << 4);

					if (VidTableVal & 0x01)
						uVidDat |= fg;

					*lpVidPtr++ = (BYTE)uVidDat;
					lpVidPtr += nStride - 4;
				}

				lpVidMem += 4;
				if (lpVidMem >= lpNewLine)
				{
					Row++;
					lpVidMem = gpMem + (UINT)((Row * nStride) * 8);
					lpNewLine = gpMem + (UINT)(((Row * 8) + 1) * nStride);
				}
				lpVidPtr = lpVidMem;
			}
			break;

		case 8:
			while (*pStr != 0)
			{
				ch = *pStr++;
				if ((ch < ' ') || (ch - ' ' > MAX_FONT-1))
					ch = '.';

				for (y = 0; y < 8; ++y)
				{
					VidTableVal = FontTable[ch - ' '][y];

					for (Byte = 0; Byte < 8; Byte++)
					{
						if (VidTableVal & 0x80)
							*lpVidPtr = (BYTE)fg;
						else
							*lpVidPtr = (BYTE)bg;

					   	lpVidPtr++;
						VidTableVal <<= 1;
					}

					lpVidPtr += nStride - 8;
				}

				lpVidMem += 8;
				if (lpVidMem >= lpNewLine)
				{
					Row++;
					lpVidMem = gpMem + (UINT)((Row * nStride) * 8);
					lpNewLine = gpMem + (UINT)(((Row * 8) + 1) * nStride);
				}
					lpVidPtr = lpVidMem;
			}
			break;
	}
}

/*-------------------------------------------------------------------------*/

