/**************************************************************************
****	SYSTEM	:	GTK6 DISPLAY DEMO BOARD				****
****	MACHINE	:	M16C/62						****
****	MONITOR	:	KD30						****
****	MODULE NAME	:	Toudemo.c				****
****	FUNCTION	:	Drive NAN YA Display with SED1375	****
****	NOTE		:	ADS7843 controlles 4 - wire analog touch****
****									****
****									****
****	REVISION NO.:		DATE:			PROGRAMMER:	****
****	Original		November 2001		Kai Gillmann	****
****									****
**************************************************************************/


/**** Include of SFR file *****************************************************/

#include    <stdio.h>
#include    <stdlib.h>
#include    "sfr62.h"
#include    "sys.h"     
#include    "sed1375.h"
#include    "ads7843.h"

/**** Define of Symbols *****************************************************/ 

unsigned char dummy;



/**** Proto-type declaration **************************************************/

#pragma INTERRUPT  ta0int		/* Declares interrupt handler TA0  */

#pragma ADDRESS PICTURE1 0D0200H
unsigned char far PICTURE1;

#pragma ADDRESS PICTURE2 0E3300H
unsigned char far PICTURE2;

#pragma ADDRESS BWPICTUREARR 0D0200H
unsigned char far BWPICTUREARR[16][0x3000];

#pragma ADDRESS BUTTONIMG1 0E3300H
unsigned char far BUTTONIMG1;

#pragma ADDRESS BUTTONIMG2 0EBB00H
unsigned char far BUTTONIMG2;

void far		main(void);

#ifndef FALSE
#define FALSE  0
#endif

#define WAITTIME 1

#define		MENU		p7_addr.bit.b2		/* Port P7  bit2 */

void far main_screen() {
  printf("\n\n (c) GTK Systems 4 admatec GmbH Hamburg");
  printf("\n                   GTK 6 ");
  printf("\n SED137x register tool, very basic one ");
  printf("\nr = read register\nR = change register");
  printf("\nv = VND--");
  printf("\nV = VND++");
  printf("\nh = HND--");
  printf("\nH = HND++");
  printf("\nB = Set BW mode 4bit");
  printf("\nC = Set Color mode 8bit");
  printf("\nD = Draw Circle at x/y position with diameter");
  printf("\ns = show register 0x00 to 0x1d");
  printf("\nl = show LUT");
  printf("\nL = edit LUT");
  printf("\n1/2 = Show Pic 1/2");
  printf("\n\n i = this info screen");
}

void far get_action() {
int dummy2;
int reg_num;
int reg_val;
int x_pos, y_pos, radius;
unsigned int i;
static unsigned char instring[10];

    switch(getchar()) {
	case 'v':  dec_NVP();
	           break;
	case 'V':  inc_NVP();
	           break;
	case 'h':  dec_NHP();
	           break;
	case 'H':  inc_NHP();
	           break;
	case 'B':  set_Displaymode( MONO );
		    break;
	case 'C':  set_Displaymode( COLOR );
		    break;
	case 'D':  printf("\nCircle X / Y position with radius");
		    printf("\nXXX: ");
		    gets(&instring[0]);
		    x_pos = (BYTE)strtol(instring, NULL, 10);
		    printf("\nYYY: ");
		    gets(&instring[0]);
		    y_pos = (BYTE)strtol(instring, NULL, 10);
		    printf("\nRRR: ");
		    gets(&instring[0]);
		    radius = (BYTE)strtol(instring, NULL, 10);
		    draw_circle(0x00, 0xf, 1, x_pos, y_pos, radius);
		    break;
	case 'R':  printf("\nChange register\nReg: ");
		    gets(&instring[0]);
		    reg_num = (BYTE)strtol(instring, NULL, 16);
		    read_register((unsigned char)reg_num);
		    printf("\nnew value <nn>\n");
		    gets(instring);
		    reg_val = (BYTE)strtol(instring, NULL, 16);
                  set_register ((unsigned char)reg_num, (unsigned char)reg_val);
		    break;
	case 'r':  printf("\nRegisternumber:");
	  	    while (ri_u0c1) dummy2 = u0rbl;
	           scanf("%2x", &reg_num);
	           read_register((unsigned char)reg_num);
		    break;
	case 's':  show_register();
	           break;
	case 'l':  show_LUT();
	           break;
	case 'L':  edit_LUT();
	           break;
	case '1':  ShowBMP ( &PICTURE1 );
		    main_screen();
		    break;
	case '2':  ShowBMP ( &PICTURE2 );
		    main_screen();
		    break;
	case '3':  for (i=0; i<0x100; i++) {              
                     draw_bar( (unsigned char)i, i, 240, 1);
                  }
		    break;
	case 'i':
	 default:  main_screen();
		    break;
    }

}


/*** Wait function ***/
void far wait( unsigned char time2wait) {
static char Displaytext[100];
   dummy = time2wait;
   do {
     if ( new_touch_value ) {
        sprintf( Displaytext, "X= %d Y= %d    ", xpos, ypos  );
        seDrawText( 24, 0, Displaytext, 0x0f, 0x00 );

//        printf("X= %d Y= %d \n", xpos, ypos);
	 if ((ypos > 20) || (xpos > 20)) {
	   draw_circle(0x1C, 0x23, 1, xpos, ypos, 20);
	 }
	 dummy = 0;
	 new_touch_value = 0;
     }
   } while( dummy );
}

void far initta0() {
  udf   = 0x00;		/* down count 		*/
  ta0mr = 0x80;		/* timer mode, f/32	2uSec @16MHz */
  ta0   = 0xC350;		/* count source 50msec            */
  ta0ic = 0x06;		/* Level 6 		             */
  tabsr = 0x01;		/* start flag 		      */
}

/**** MAIN **************************************************************/
 
void far main()
{ 
unsigned char Displaytext[250];
unsigned char color = 0xf0;
unsigned char BWpicturecnt = 0;
 
asm( "\tFSET	I");	/* Enable interrupt */

/**** Setting Properties ****************************************************/
/**** Initialising Values ****************************************************/
pd7_2 = 0;		/* set port7.0 (MENU KEY) as input */
pu16  = 1;		/* Pull-up P70 to P73 */
processor_mode_set();

//system_clock_set_main_clock();

printf("\nSED1375 wird initialisiert");
if ( TRUE != init_sed1375()) {
  printf ("WARNUNG: Initialisierung fehlgeschlagen !!!!!! \n");
} else {
  printf (" OK \n");
}

clear_display();

initta0();

set_Displaymode( COLOR );  // MONO

ShowBMP( &PICTURE1 );
wait( WAITTIME * 20 );
ADS_init();	       /* init ADS7843 interface and controller */

if ( !MENU ) main_screen();
//while (1) {
  // wait (255);
//}
while (1) {
  while( !MENU ) {
    get_action();
  }
  
  if ( !new_touch_value ) {
    draw_bar(color++ , 0, 240, 320);
    if (ShowBMP( &PICTURE2 ) == TRUE ) {
       wait( 255 );
    }
  }
 
  if ( !new_touch_value ) {
    draw_bar(color++ , 0, 240, 320);
    if (ShowBMP( &PICTURE1 ) == TRUE ) {
       wait( 255 );
    }
  }
  else {
    if (ShowBMPat( &BUTTONIMG1, 16, 191 ) == TRUE ) {
       new_touch_value = 0;
       wait( 255 );
    }
    sprintf( Displaytext, "Hallo liebe Freunde, jetzt auch mit Text" );
    seDrawText( 24, 0, Displaytext, 0x00, 0x0C );
    new_touch_value = 0;
    wait( 255 );

    draw_circle(0x1C, 0x23, 1, 160, 120, 60);
    new_touch_value = 0;
    wait( 255 );

    if (ShowBMPat( &BUTTONIMG2, 16, 191 ) == TRUE ) {
       new_touch_value = 0;
       wait( 255 );
    }
    if (ShowBMP( &PICTURE1 ) == TRUE ) {
       new_touch_value = 0;
       wait( 255 );
    }
  }

  
}

}
/**** Interrupt Routine ta0int() ************************************************/


void far ta0int(void)
{
        if (dummy > 0) dummy--;
        return;
}

/**************************************************************************
****			    admatec GmbH	 		       ****
***************************************************************************/
